
%% collision detection test init values
obstacle_position = [-5 70  10];
ro = obstacle_position(3);
obsVelocity = [7 -3];
target = [170 90]';
eta = [0 0]';
thresholdValues = 10;
chi_v = atan2(target(2)-eta(2),target(1)-eta(1));
chi_o = atan2(obsVelocity(2),obsVelocity(1));
V_o = norm(obsVelocity);
t = 0:55;
V_v = 7;

%% Estimation of the trajectoris

O = [V_o*t*cos(chi_o) + obstacle_position(1);V_o*t*sin(chi_o) + obstacle_position(2)];


N = [V_v*t*cos(chi_v)+ eta(1);V_v*t*sin(chi_v)+ eta(2)];


d = sqrt((O(1,:)-N(1,:)).^2+(O(2,:)-N(2,:)).^2);
for i = 1:55
    if d(i) < ro
        disp('Under threshold value')
        collision = O(i);
        time = i;
        break;
    end
end


%% start plotting
figure(1);clf
hold on
plot(t(1:22),d(1:22),'k');
plot(0:21,10*ones(1,22),'r');
xlabel('time [s]')
ylabel('distance [m]')
legend('f(t)','Threshold Value');
title('Collision detection test');

figure(2);clf
hold on
axis equal
w = 0:0.1:2.1*pi;
plot(O(1,1:22),O(2,1:22),'--r')
plot([eta(1) target(1)],[eta(2) target(2)],'--k')

if time == 1
    time =2;
end
plot(O(1,time)+ thresholdValues*cos(w),O(2,time)+thresholdValues*sin(w),'k')
plot([eta(1) target(1) obstacle_position(1)],[eta(2) target(2) obstacle_position(2)],'*k')

plot([obstacle_position(1)+obstacle_position(3)*cos(w)],[obstacle_position(2)+obstacle_position(3)*sin(w)],'r')

%plot(O(1,1:22),O(2,1:22),'--r')

plot(O(1,time),O(2,time),'*k')
plot(N(1,time),N(2,time),'*k')
count = 6;
breakNow = 0;
for i = 1:time
    
    if count == 6 || i == time-1
        plot([O(1,i) N(1,i)],[O(2,i) N(2,i)],'--g')
        plot(O(1,i),O(2,i),'*r')
        plot(N(1,i),N(2,i),'*r')
        
        text(O(1,i)+(-O(1,i)+N(1,i))/2+4,O(2,i)+(-O(2,i)+N(2,i))/2,['t = ' num2str(i)])
        count  = 1;
        breakNow = breakNow +1;
        if breakNow == 2
            break;
        end
    end
    count = count +1;
    
end
plot([O(1,time) N(1,time)],[O(2,time) N(2,time)],'--g')
text(O(1,time)+(-O(1,time)+N(1,time))/2+4,O(2,time)+(-O(2,time)+N(2,time))/2,['t = ' num2str(time)])
text(eta(1)+5,eta(2),'Vehicle')
text(obstacle_position(1)-9,obstacle_position(2)+5,'Obstacle')
xlabel('x [m]')
ylabel('y [m]')
title('xy-plot of a collision detection test')
legend('vehicle trajectory','obstacle trajectory','ThresholdValues')