%% perfect signals

x                           = logsout.get('eta_obstacle').Values.Data(:,1);
y                           = logsout.get('eta_obstacle').Values.Data(:,2);
theta                       = logsout.get('eta_obstacle').Values.Data(:,3);


dot_x                       = logsout.get('nu_obstacle').Values.Data(:,1);
dot_y                       = logsout.get('nu_obstacle').Values.Data(:,2);
dot_theta                   = logsout.get('nu_obstacle').Values.Data(:,3);

a_x                         = logsout.get('a_obstacle').Values.Data(:,1);
a_y                         = logsout.get('a_obstacle').Values.Data(:,2);
a_theta                     = logsout.get('a_obstacle').Values.Data(:,3);

%% measured signals

x_m                         = logsout.get('measuredEta').Values.Data(:,1);
y_m                         = logsout.get('measuredEta').Values.Data(:,2);
theta_m                     = logsout.get('measuredEta').Values.Data(:,3);



%% kalman in NED

disk_kal_ned_u              = logsout.get('VelNED').Values.Data(:,1);
disk_kal_ned_v              = logsout.get('VelNED').Values.Data(:,2);

disk_kal_x                  = logsout.get('disk_kal_x').Values.Data(:,1);
disk_kal_y                  = logsout.get('disk_kal_x').Values.Data(:,2);
disk_kal_theta              = logsout.get('disk_kal_x').Values.Data(:,3);


disk_kal_dot_x              = logsout.get('disk_kal_x').Values.Data(:,4);
disk_kal_dot_y              = logsout.get('disk_kal_x').Values.Data(:,5);
disk_kal_dot_theta =0;

disk_kal_dot_u              = logsout.get('disk_kal_x').Values.Data(:,6);
disk_kal_dot_v              = logsout.get('disk_kal_x').Values.Data(:,7);
disk_kal_dot_r =0;

t                           = logsout.get('disk_kal_x').Values.Time;



disk_kal2_x                 = logsout.get('x_hat_method2').Values.Data(:,1);
disk_kal2_y                 = logsout.get('x_hat_method2').Values.Data(:,2);

disk_kal2_theta             = logsout.get('x_hat_method2').Values.Data(:,3);

disk_kal2_u                 = logsout.get('x_hat_method2').Values.Data(:,4);
disk_kal2_v                 = logsout.get('x_hat_method2').Values.Data(:,5);
disk_kal2_r = 0;







%% start plotting
figure(1);clf
hold on


subplot(3,1,1)
hold on
plot(t,x_m,'r')
plot(t,disk_kal_x)



title('Estimated x-position')
xlabel('time [seconds]')
ylabel('x [meter]')


subplot(3,1,2)
hold on
plot(t,y_m,'r')
plot(t,disk_kal_y)
title('Estimated y-position')
xlabel('time [seconds]')
ylabel('y [meter]')


subplot(3,1,3)
hold on
plot(t,theta,'--r')
plot(t,disk_kal_theta)
title('Estimated heading \theta_o')
xlabel('time [seconds]')
ylabel('\theta_o [rad]')



figure(2);clf
hold on


subplot(3,1,1)
hold on
plot(t,dot_x,'--r')
plot(t,disk_kal_dot_x)
title('Estimated velocity u in body')
xlabel('time [second]')
ylabel('u [m/s]')


subplot(3,1,2)
hold on
plot(t,dot_y,'--r')
plot(t,disk_kal_dot_y)
title('Estimated velocity v in body')
xlabel('time [second]')
ylabel('v [m/s]')

subplot(3,1,3)
start1 = 50;
end1 = 70;
start2 = 120;
end2 = 140;
plot(t(start2/0.01:end2/0.01), dot_x(start2/0.01:end2/0.01)-disk_kal_dot_x(start2/0.01:end2/0.01))
title('Error between the true value and the estimated u')

xlabel('time [second]')
ylabel('Error [m/s]')




figure(4);clf
hold on
plot(x_m,y_m,'--r')
plot(disk_kal_x,disk_kal_y)


for i = 1:size(WP,2);
    
   plot(WP(1,i),WP(2,i),'k*') 
   
end

for i = 1:size(WP,2)-1;
    
   plot([WP(1,i) WP(1,i+1)],[WP(2,i) WP(2,i+1)],'k--') 
   
end

title('xy plot of the estimated trajectory')
xlabel('x [meter]')
ylabel('y [meter]')



figure(50);clf
subplot(3,1,1)
hold on
plot(t(1/0.01:end),x(1/0.01:end)-disk_kal_x(1/0.01:end))
xlabel('Time [second]')
ylabel('Error in x [m]')

title('Error between the estimated and the true \eta')



subplot(3,1,2)
hold on
plot(t(1/0.01:end),y(1/0.01:end)-disk_kal_y(1/0.01:end))
xlabel('Time [second]')
ylabel('Error in y [m]')

subplot(3,1,3)
hold on
plot(t(50/0.01:end),theta(50/0.01:end)-disk_kal_theta(50/0.01:end))

xlabel('Time [second]')
ylabel('Error in \theta_o [rad]')



%% start kalman method two in body 2.1

figure(6);clf
hold on


subplot(3,1,1)
hold on
plot(t,x,'--r')
plot(t,disk_kal2_x)
legend('true Value','Estimated Value','location','SouthEast')
title('Estimated x position')
xlabel('time [s]');
ylabel('x [m]');
subplot(3,1,2)
hold on
plot(t,y,'--r')
plot(t,disk_kal2_y)

legend('true Value','Estimated Value','location','SouthEast')
title('Estimated y position')
xlabel('time [s]');
ylabel('y [m]')
subplot(3,1,3)
hold on
plot(t,theta,'--r')
plot(t,disk_kal2_theta)
title('Estimated heading')
xlabel('time [s]');
ylabel('\theta_o [rad]')
legend('true Value','Estimated Value','location','SouthEast')


figure(7);clf
hold on
subplot(2,1,1)
hold on
plot(t,dot_x,'--r')
plot(t,disk_kal2_u)

title('Estimated velocity u')
xlabel('time [s]');
ylabel('u [m/s]');


legend('true Value','Estimated Value','location','SouthEast')
subplot(2,1,2)
hold on
plot(t,dot_y,'--r')
plot(t,disk_kal2_v)
% 
% 
legend('true Value','Estimated Value','location','SouthEast')
title('Estimated velocity v')
xlabel('time [s]');
ylabel('v [m/s]');
figure(8);clf
hold on
plot(x,y,'--r')
plot(disk_kal2_x,disk_kal2_y)


for i = 1:size(WP,2);
    
   plot(WP(1,i),WP(2,i),'k*') 
   
end


title('Estimated xy-plot')
xlabel('x [m]');
ylabel('y [m]');


