function figure_keypress
    figure('KeyPressFcn',@printfig);
    surf(peaks)
    
    function printfig(src,event)
    % Callback to parse keypress event data to print a figure
        if event.Character == 'p'
            % On some systems you must send the file to a printer manually
            if length(event.Modifier) == 1 && ...
                strcmp(event.Modifier{:},'control')
                % Create PDF file of figure when Ctrl key is down
                print ('-dpdf',['-f' num2str(src)])
            elseif isempty(event.Modifier)
                % Print PNG image of figure when Ctrl is not pressed
                print ('-dpng','-r200',['-f' num2str(src)])
            end
        end
    end
end