/* Include files */

#include "blascompat32.h"
#include "NSB_vehicle_simulator_sfun.h"
#include "c4_NSB_vehicle_simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "NSB_vehicle_simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c4_debug_family_names[30] = { "SearchDistance", "p_o", "d",
  "temp_d", "heading_vehicle", "DistanceToCollision", "CollisionThreat", "i",
  "tempdist", "temp_CollisionThreat", "Temp_DistanceToClosesCollision",
  "ObstacleInPath", "headingObstacle", "threat", "NewDiraction", "p_obs", "back",
  "nargin", "nargout", "v_vessel", "eta", "obslist", "velObs", "target",
  "obstacleToCollisionAvoidance", "V_obs", "diractionAround",
  "increaseSafetyCircle", "safetyCircle", "backSituation" };

static const char * c4_b_debug_family_names[18] = { "chi_v", "chi_o", "V_o", "t",
  "V_v", "O", "N", "D", "nargin", "nargout", "v_o", "obs", "ro", "eta",
  "V_vessel", "target", "CollisionThreat", "DistanceToClosesCollision" };

static const char * c4_c_debug_family_names[18] = { "etaWp", "k", "h", "eps",
  "A", "B", "C", "x1", "x2", "y1", "y2", "nargin", "nargout", "obs", "ro", "eta",
  "target", "St" };

static const char * c4_d_debug_family_names[5] = { "nargin", "nargout",
  "V_obstacle", "NewDiraction", "lastVelocity" };

static const char * c4_e_debug_family_names[4] = { "nargin", "nargout", "theta",
  "R_matrix" };

static const char * c4_f_debug_family_names[12] = { "HeadsOnConstant",
  "collisionFromBehindConstant", "v_ov", "h_ov_rad", "temp_angle", "nargin",
  "nargout", "heading_vehicle", "velocity_obs", "kvadra", "headsOn", "back" };

static const char * c4_g_debug_family_names[15] = { "theta_obstacle", "kvadrant",
  "headsOn", "nargin", "nargout", "V_obstacle", "d", "heading_vehicle", "P_veh",
  "P_obs", "target", "ClockWise", "dist", "pos_obs", "back" };

/* Function Declarations */
static void initialize_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void initialize_params_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void enable_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void disable_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void c4_update_debugger_state_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void set_sim_state_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance, const mxArray *c4_st);
static void finalize_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void sf_c4_NSB_vehicle_simulator(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);
static void c4_chartstep_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void initSimStructsc4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData);
static real_T c4_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_backSituation, const char_T *c4_identifier);
static real_T c4_b_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static real_T c4_c_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_safetyCircle, const char_T *c4_identifier);
static real_T c4_d_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static real_T c4_e_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_increaseSafetyCircle, const char_T
  *c4_identifier);
static real_T c4_f_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_d_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static real_T c4_g_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_diractionAround, const char_T
  *c4_identifier);
static real_T c4_h_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_e_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_i_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_V_obs, const char_T *c4_identifier, real_T
  c4_y[2]);
static void c4_j_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2]);
static void c4_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_f_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_k_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_obstacleToCollisionAvoidance, const char_T
  *c4_identifier, real_T c4_y[7]);
static void c4_l_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[7]);
static void c4_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_g_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static const mxArray *c4_h_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static const mxArray *c4_i_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static const mxArray *c4_j_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static real_T c4_m_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static void c4_n_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2]);
static void c4_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static void c4_o_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[3]);
static void c4_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_k_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_p_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[51]);
static void c4_j_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_l_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_q_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[102]);
static void c4_k_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_m_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_r_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_lastVelocity, const char_T *c4_identifier,
  real_T c4_y[2]);
static void c4_s_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2]);
static void c4_l_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_n_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_t_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[4]);
static void c4_m_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[74]);
static real_T c4_norm(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
                      real_T c4_x[2]);
static void c4_eml_realmin(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);
static void c4_check_forloop_overflow_error
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static void c4_CollisionDetection(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c4_v_o[2], real_T c4_obs[2], real_T c4_ro, real_T
  c4_eta[3], real_T c4_V_vessel[3], real_T c4_target[2], real_T
  *c4_CollisionThreat, real_T *c4_DistanceToClosesCollision);
static real_T c4_atan2(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_y, real_T c4_x);
static void c4_eml_scalar_eg(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);
static real_T c4_b_norm(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_x[2]);
static real_T c4_c_norm(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_x[3]);
static void c4_power(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
                     real_T c4_a[51], real_T c4_y[51]);
static void c4_eml_error(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance);
static real_T c4_ObstacleInpath(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c4_obs[3], real_T c4_ro, real_T c4_eta[3], real_T
  c4_target[2]);
static real_T c4_mpower(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_a);
static void c4_ChooseDirection(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c4_V_obstacle[2], real_T c4_d, real_T
  c4_heading_vehicle, real_T c4_P_veh[2], real_T c4_P_obs[2], real_T c4_target[2],
  real_T *c4_ClockWise, real_T *c4_dist, real_T c4_pos_obs[2], real_T *c4_back);
static void c4_kvad(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
                    real_T c4_heading_vehicle, real_T c4_velocity_obs[2], real_T
                    *c4_kvadra, real_T *c4_headsOn, real_T *c4_back);
static void c4_R(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance, real_T
                 c4_theta, real_T c4_R_matrix[4]);
static void c4_b_eml_scalar_eg(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);
static const mxArray *c4_o_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static int32_T c4_u_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_n_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static uint8_T c4_v_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_is_active_c4_NSB_vehicle_simulator, const
  char_T *c4_identifier);
static uint8_T c4_w_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void init_dsm_address_info(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  chartInstance->c4_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c4_diractionAround_not_empty = FALSE;
  chartInstance->c4_increaseSafetyCircle_not_empty = FALSE;
  chartInstance->c4_safetyCircle_not_empty = FALSE;
  chartInstance->c4_backSituation_not_empty = FALSE;
  chartInstance->c4_lastVelocity_not_empty = FALSE;
  chartInstance->c4_is_active_c4_NSB_vehicle_simulator = 0U;
}

static void initialize_params_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void enable_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c4_update_debugger_state_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  const mxArray *c4_st;
  const mxArray *c4_y = NULL;
  int32_T c4_i0;
  real_T c4_u[2];
  const mxArray *c4_b_y = NULL;
  int32_T c4_i1;
  real_T c4_b_u[7];
  const mxArray *c4_c_y = NULL;
  real_T c4_hoistedGlobal;
  real_T c4_c_u;
  const mxArray *c4_d_y = NULL;
  real_T c4_b_hoistedGlobal;
  real_T c4_d_u;
  const mxArray *c4_e_y = NULL;
  real_T c4_c_hoistedGlobal;
  real_T c4_e_u;
  const mxArray *c4_f_y = NULL;
  int32_T c4_i2;
  real_T c4_f_u[2];
  const mxArray *c4_g_y = NULL;
  real_T c4_d_hoistedGlobal;
  real_T c4_g_u;
  const mxArray *c4_h_y = NULL;
  uint8_T c4_e_hoistedGlobal;
  uint8_T c4_h_u;
  const mxArray *c4_i_y = NULL;
  real_T (*c4_obstacleToCollisionAvoidance)[7];
  real_T (*c4_V_obs)[2];
  c4_V_obs = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_obstacleToCollisionAvoidance = (real_T (*)[7])ssGetOutputPortSignal
    (chartInstance->S, 1);
  c4_st = NULL;
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(8), FALSE);
  for (c4_i0 = 0; c4_i0 < 2; c4_i0++) {
    c4_u[c4_i0] = (*c4_V_obs)[c4_i0];
  }

  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_setcell(c4_y, 0, c4_b_y);
  for (c4_i1 = 0; c4_i1 < 7; c4_i1++) {
    c4_b_u[c4_i1] = (*c4_obstacleToCollisionAvoidance)[c4_i1];
  }

  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", c4_b_u, 0, 0U, 1U, 0U, 1, 7), FALSE);
  sf_mex_setcell(c4_y, 1, c4_c_y);
  c4_hoistedGlobal = chartInstance->c4_backSituation;
  c4_c_u = c4_hoistedGlobal;
  c4_d_y = NULL;
  if (!chartInstance->c4_backSituation_not_empty) {
    sf_mex_assign(&c4_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c4_d_y, sf_mex_create("y", &c4_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c4_y, 2, c4_d_y);
  c4_b_hoistedGlobal = chartInstance->c4_diractionAround;
  c4_d_u = c4_b_hoistedGlobal;
  c4_e_y = NULL;
  if (!chartInstance->c4_diractionAround_not_empty) {
    sf_mex_assign(&c4_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c4_e_y, sf_mex_create("y", &c4_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c4_y, 3, c4_e_y);
  c4_c_hoistedGlobal = chartInstance->c4_increaseSafetyCircle;
  c4_e_u = c4_c_hoistedGlobal;
  c4_f_y = NULL;
  if (!chartInstance->c4_increaseSafetyCircle_not_empty) {
    sf_mex_assign(&c4_f_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c4_f_y, sf_mex_create("y", &c4_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c4_y, 4, c4_f_y);
  for (c4_i2 = 0; c4_i2 < 2; c4_i2++) {
    c4_f_u[c4_i2] = chartInstance->c4_lastVelocity[c4_i2];
  }

  c4_g_y = NULL;
  if (!chartInstance->c4_lastVelocity_not_empty) {
    sf_mex_assign(&c4_g_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c4_g_y, sf_mex_create("y", c4_f_u, 0, 0U, 1U, 0U, 2, 1, 2),
                  FALSE);
  }

  sf_mex_setcell(c4_y, 5, c4_g_y);
  c4_d_hoistedGlobal = chartInstance->c4_safetyCircle;
  c4_g_u = c4_d_hoistedGlobal;
  c4_h_y = NULL;
  if (!chartInstance->c4_safetyCircle_not_empty) {
    sf_mex_assign(&c4_h_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c4_h_y, sf_mex_create("y", &c4_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c4_y, 6, c4_h_y);
  c4_e_hoistedGlobal = chartInstance->c4_is_active_c4_NSB_vehicle_simulator;
  c4_h_u = c4_e_hoistedGlobal;
  c4_i_y = NULL;
  sf_mex_assign(&c4_i_y, sf_mex_create("y", &c4_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 7, c4_i_y);
  sf_mex_assign(&c4_st, c4_y, FALSE);
  return c4_st;
}

static void set_sim_state_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance, const mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T c4_dv0[2];
  int32_T c4_i3;
  real_T c4_dv1[7];
  int32_T c4_i4;
  real_T c4_dv2[2];
  int32_T c4_i5;
  real_T (*c4_obstacleToCollisionAvoidance)[7];
  real_T (*c4_V_obs)[2];
  c4_V_obs = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_obstacleToCollisionAvoidance = (real_T (*)[7])ssGetOutputPortSignal
    (chartInstance->S, 1);
  chartInstance->c4_doneDoubleBufferReInit = TRUE;
  c4_u = sf_mex_dup(c4_st);
  c4_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 0)),
                        "V_obs", c4_dv0);
  for (c4_i3 = 0; c4_i3 < 2; c4_i3++) {
    (*c4_V_obs)[c4_i3] = c4_dv0[c4_i3];
  }

  c4_k_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 1)),
                        "obstacleToCollisionAvoidance", c4_dv1);
  for (c4_i4 = 0; c4_i4 < 7; c4_i4++) {
    (*c4_obstacleToCollisionAvoidance)[c4_i4] = c4_dv1[c4_i4];
  }

  chartInstance->c4_backSituation = c4_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 2)), "backSituation");
  chartInstance->c4_diractionAround = c4_g_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 3)), "diractionAround");
  chartInstance->c4_increaseSafetyCircle = c4_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 4)), "increaseSafetyCircle");
  c4_r_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 5)),
                        "lastVelocity", c4_dv2);
  for (c4_i5 = 0; c4_i5 < 2; c4_i5++) {
    chartInstance->c4_lastVelocity[c4_i5] = c4_dv2[c4_i5];
  }

  chartInstance->c4_safetyCircle = c4_c_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 6)), "safetyCircle");
  chartInstance->c4_is_active_c4_NSB_vehicle_simulator = c4_v_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 7)),
     "is_active_c4_NSB_vehicle_simulator");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_NSB_vehicle_simulator(chartInstance);
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void sf_c4_NSB_vehicle_simulator(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
  int32_T c4_i6;
  int32_T c4_i7;
  int32_T c4_i8;
  int32_T c4_i9;
  int32_T c4_i10;
  int32_T c4_i11;
  int32_T c4_i12;
  real_T (*c4_target)[2];
  real_T (*c4_V_obs)[2];
  real_T (*c4_velObs)[4];
  real_T (*c4_obslist)[4];
  real_T (*c4_obstacleToCollisionAvoidance)[7];
  real_T (*c4_eta)[3];
  real_T (*c4_v_vessel)[3];
  c4_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 4);
  c4_V_obs = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_velObs = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c4_obslist = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c4_obstacleToCollisionAvoidance = (real_T (*)[7])ssGetOutputPortSignal
    (chartInstance->S, 1);
  c4_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c4_v_vessel = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  for (c4_i6 = 0; c4_i6 < 3; c4_i6++) {
    _SFD_DATA_RANGE_CHECK((*c4_v_vessel)[c4_i6], 0U);
  }

  for (c4_i7 = 0; c4_i7 < 3; c4_i7++) {
    _SFD_DATA_RANGE_CHECK((*c4_eta)[c4_i7], 1U);
  }

  for (c4_i8 = 0; c4_i8 < 7; c4_i8++) {
    _SFD_DATA_RANGE_CHECK((*c4_obstacleToCollisionAvoidance)[c4_i8], 2U);
  }

  for (c4_i9 = 0; c4_i9 < 4; c4_i9++) {
    _SFD_DATA_RANGE_CHECK((*c4_obslist)[c4_i9], 3U);
  }

  for (c4_i10 = 0; c4_i10 < 4; c4_i10++) {
    _SFD_DATA_RANGE_CHECK((*c4_velObs)[c4_i10], 4U);
  }

  for (c4_i11 = 0; c4_i11 < 2; c4_i11++) {
    _SFD_DATA_RANGE_CHECK((*c4_V_obs)[c4_i11], 5U);
  }

  for (c4_i12 = 0; c4_i12 < 2; c4_i12++) {
    _SFD_DATA_RANGE_CHECK((*c4_target)[c4_i12], 6U);
  }

  chartInstance->c4_sfEvent = CALL_EVENT;
  c4_chartstep_c4_NSB_vehicle_simulator(chartInstance);
  sf_debug_check_for_state_inconsistency(_NSB_vehicle_simulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c4_chartstep_c4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  int32_T c4_i13;
  real_T c4_v_vessel[3];
  int32_T c4_i14;
  real_T c4_eta[3];
  int32_T c4_i15;
  real_T c4_obslist[4];
  int32_T c4_i16;
  real_T c4_velObs[4];
  int32_T c4_i17;
  real_T c4_target[2];
  uint32_T c4_debug_family_var_map[30];
  real_T c4_SearchDistance;
  real_T c4_p_o[3];
  real_T c4_d;
  real_T c4_temp_d;
  real_T c4_heading_vehicle;
  real_T c4_DistanceToCollision;
  real_T c4_CollisionThreat;
  real_T c4_i;
  real_T c4_tempdist;
  real_T c4_temp_CollisionThreat;
  real_T c4_Temp_DistanceToClosesCollision;
  real_T c4_ObstacleInPath;
  real_T c4_headingObstacle;
  real_T c4_threat;
  real_T c4_NewDiraction;
  real_T c4_p_obs[2];
  real_T c4_back;
  real_T c4_nargin = 5.0;
  real_T c4_nargout = 2.0;
  real_T c4_obstacleToCollisionAvoidance[7];
  real_T c4_V_obs[2];
  int32_T c4_i18;
  int32_T c4_i19;
  real_T c4_b_obslist[3];
  int32_T c4_i20;
  int32_T c4_i21;
  real_T c4_c_obslist[2];
  int32_T c4_i22;
  real_T c4_b_velObs[2];
  int32_T c4_i23;
  real_T c4_d_obslist[2];
  int32_T c4_i24;
  real_T c4_b_eta[3];
  int32_T c4_i25;
  real_T c4_b_v_vessel[3];
  int32_T c4_i26;
  real_T c4_b_target[2];
  real_T c4_b_Temp_DistanceToClosesCollision;
  real_T c4_b_temp_CollisionThreat;
  real_T c4_e_obslist[3];
  int32_T c4_i27;
  int32_T c4_i28;
  int32_T c4_i29;
  real_T c4_b_p_o[3];
  int32_T c4_i30;
  real_T c4_c_eta[3];
  int32_T c4_i31;
  real_T c4_c_target[2];
  int32_T c4_i32;
  real_T c4_c_v_vessel[3];
  int32_T c4_i33;
  real_T c4_V_obstacle[2];
  uint32_T c4_b_debug_family_var_map[5];
  real_T c4_b_nargin = 1.0;
  real_T c4_b_nargout = 1.0;
  int32_T c4_i34;
  int32_T c4_i35;
  real_T c4_b_V_obstacle[2];
  int32_T c4_i36;
  int32_T c4_i37;
  real_T c4_b_V_obs[2];
  int32_T c4_i38;
  real_T c4_d_eta[2];
  int32_T c4_i39;
  real_T c4_c_p_o[2];
  int32_T c4_i40;
  real_T c4_d_target[2];
  real_T c4_b_back;
  real_T c4_b_p_obs[2];
  real_T c4_b_safetyCircle;
  real_T c4_b_diractionAround;
  int32_T c4_i41;
  real_T c4_hoistedGlobal;
  real_T c4_A;
  real_T c4_B;
  real_T c4_x;
  real_T c4_y;
  real_T c4_b_x;
  real_T c4_b_y;
  int32_T c4_i42;
  int32_T c4_i43;
  real_T c4_c_V_obs[2];
  int32_T c4_i44;
  real_T c4_e_eta[2];
  int32_T c4_i45;
  real_T c4_d_p_o[2];
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_e_x;
  real_T c4_f_x;
  int32_T c4_i46;
  real_T c4_e_p_o[2];
  real_T c4_d0;
  real_T c4_g_x[2];
  int32_T c4_i47;
  real_T c4_a;
  int32_T c4_i48;
  real_T c4_f_p_o[7];
  int32_T c4_i49;
  int32_T c4_i50;
  int32_T c4_i51;
  real_T (*c4_b_obstacleToCollisionAvoidance)[7];
  real_T (*c4_d_V_obs)[2];
  real_T (*c4_e_target)[2];
  real_T (*c4_c_velObs)[4];
  real_T (*c4_f_obslist)[4];
  real_T (*c4_f_eta)[3];
  real_T (*c4_d_v_vessel)[3];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  boolean_T guard5 = FALSE;
  c4_e_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 4);
  c4_d_V_obs = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_c_velObs = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c4_f_obslist = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c4_b_obstacleToCollisionAvoidance = (real_T (*)[7])ssGetOutputPortSignal
    (chartInstance->S, 1);
  c4_f_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c4_d_v_vessel = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  for (c4_i13 = 0; c4_i13 < 3; c4_i13++) {
    c4_v_vessel[c4_i13] = (*c4_d_v_vessel)[c4_i13];
  }

  for (c4_i14 = 0; c4_i14 < 3; c4_i14++) {
    c4_eta[c4_i14] = (*c4_f_eta)[c4_i14];
  }

  for (c4_i15 = 0; c4_i15 < 4; c4_i15++) {
    c4_obslist[c4_i15] = (*c4_f_obslist)[c4_i15];
  }

  for (c4_i16 = 0; c4_i16 < 4; c4_i16++) {
    c4_velObs[c4_i16] = (*c4_c_velObs)[c4_i16];
  }

  for (c4_i17 = 0; c4_i17 < 2; c4_i17++) {
    c4_target[c4_i17] = (*c4_e_target)[c4_i17];
  }

  sf_debug_symbol_scope_push_eml(0U, 30U, 30U, c4_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c4_SearchDistance, 0U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_p_o, 1U, c4_i_sf_marshallOut,
    c4_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_d, 2U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_temp_d, 3U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_heading_vehicle, 4U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_DistanceToCollision, 5U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_CollisionThreat, 6U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c4_i, 7U, c4_j_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_tempdist, 8U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_temp_CollisionThreat, 9U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Temp_DistanceToClosesCollision,
    10U, c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_ObstacleInPath, 11U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_headingObstacle, 12U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_threat, 13U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_NewDiraction, 14U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_p_obs, 15U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_back, 16U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 17U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 18U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c4_v_vessel, 19U, c4_i_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_eta, 20U, c4_i_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_obslist, 21U, c4_h_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_velObs, 22U, c4_h_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_target, 23U, c4_g_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c4_obstacleToCollisionAvoidance, 24U,
    c4_f_sf_marshallOut, c4_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_V_obs, 25U, c4_e_sf_marshallOut,
    c4_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c4_diractionAround,
    26U, c4_d_sf_marshallOut, c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable
    (&chartInstance->c4_increaseSafetyCircle, 27U, c4_c_sf_marshallOut,
     c4_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c4_safetyCircle, 28U,
    c4_b_sf_marshallOut, c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c4_backSituation, 29U,
    c4_sf_marshallOut, c4_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 3);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 5);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 6);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 8);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c4_diractionAround_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 9);
    chartInstance->c4_diractionAround = 1.0;
    chartInstance->c4_diractionAround_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 13);
  if (CV_EML_IF(0, 1, 1, !chartInstance->c4_backSituation_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 14);
    chartInstance->c4_backSituation = 0.0;
    chartInstance->c4_backSituation_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 18);
  if (CV_EML_IF(0, 1, 2, !chartInstance->c4_safetyCircle_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 19);
    chartInstance->c4_safetyCircle = 0.0;
    chartInstance->c4_safetyCircle_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 21);
  if (CV_EML_IF(0, 1, 3, !chartInstance->c4_increaseSafetyCircle_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 22);
    chartInstance->c4_increaseSafetyCircle = 1.0;
    chartInstance->c4_increaseSafetyCircle_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 25);
  c4_SearchDistance = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 26);
  for (c4_i18 = 0; c4_i18 < 2; c4_i18++) {
    c4_V_obs[c4_i18] = c4_velObs[c4_i18];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 27);
  for (c4_i19 = 0; c4_i19 < 2; c4_i19++) {
    c4_b_obslist[c4_i19] = c4_obslist[c4_i19];
  }

  c4_b_obslist[2] = 0.0;
  for (c4_i20 = 0; c4_i20 < 3; c4_i20++) {
    c4_p_o[c4_i20] = c4_b_obslist[c4_i20];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 28);
  c4_d = c4_obslist[2];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 29);
  c4_temp_d = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 30);
  c4_heading_vehicle = c4_eta[2];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 31);
  c4_DistanceToCollision = 9999.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 32);
  c4_CollisionThreat = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 36);
  c4_i = 1.0;
  CV_EML_FOR(0, 1, 0, 1);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 39);
  for (c4_i21 = 0; c4_i21 < 2; c4_i21++) {
    c4_c_obslist[c4_i21] = c4_obslist[c4_i21] - c4_eta[c4_i21];
  }

  c4_tempdist = c4_norm(chartInstance, c4_c_obslist);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 41);
  if (CV_EML_IF(0, 1, 4, c4_SearchDistance > c4_tempdist)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 42);
    c4_obslist[3] = 1.0;
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 52);
  c4_i = 1.0;
  CV_EML_FOR(0, 1, 1, 1);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 53);
  if (CV_EML_IF(0, 1, 5, c4_obslist[3] > 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 54);
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 55);
    for (c4_i22 = 0; c4_i22 < 2; c4_i22++) {
      c4_b_velObs[c4_i22] = c4_velObs[c4_i22];
    }

    for (c4_i23 = 0; c4_i23 < 2; c4_i23++) {
      c4_d_obslist[c4_i23] = c4_obslist[c4_i23];
    }

    for (c4_i24 = 0; c4_i24 < 3; c4_i24++) {
      c4_b_eta[c4_i24] = c4_eta[c4_i24];
    }

    for (c4_i25 = 0; c4_i25 < 3; c4_i25++) {
      c4_b_v_vessel[c4_i25] = c4_v_vessel[c4_i25];
    }

    for (c4_i26 = 0; c4_i26 < 2; c4_i26++) {
      c4_b_target[c4_i26] = c4_target[c4_i26];
    }

    c4_CollisionDetection(chartInstance, c4_b_velObs, c4_d_obslist, c4_obslist[2],
                          c4_b_eta, c4_b_v_vessel, c4_b_target,
                          &c4_b_temp_CollisionThreat,
                          &c4_b_Temp_DistanceToClosesCollision);
    c4_temp_CollisionThreat = c4_b_temp_CollisionThreat;
    c4_Temp_DistanceToClosesCollision = c4_b_Temp_DistanceToClosesCollision;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 57);
    c4_d = c4_obslist[2];
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 58);
    guard5 = FALSE;
    if (CV_EML_COND(0, 1, 0, c4_Temp_DistanceToClosesCollision <
                    c4_DistanceToCollision)) {
      if (CV_EML_COND(0, 1, 1, c4_temp_CollisionThreat == 1.0)) {
        CV_EML_MCDC(0, 1, 0, TRUE);
        CV_EML_IF(0, 1, 6, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 60);
        c4_DistanceToCollision = c4_Temp_DistanceToClosesCollision;
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 61);
        c4_CollisionThreat = 1.0;
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 63);
        c4_e_obslist[0] = c4_obslist[0];
        c4_e_obslist[1] = c4_obslist[1];
        c4_e_obslist[2] = 1.0;
        for (c4_i27 = 0; c4_i27 < 3; c4_i27++) {
          c4_p_o[c4_i27] = c4_e_obslist[c4_i27];
        }

        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 64);
        c4_temp_d = c4_obslist[2];
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 65);
        for (c4_i28 = 0; c4_i28 < 2; c4_i28++) {
          c4_V_obs[c4_i28] = c4_velObs[c4_i28];
        }
      } else {
        guard5 = TRUE;
      }
    } else {
      guard5 = TRUE;
    }

    if (guard5 == TRUE) {
      CV_EML_MCDC(0, 1, 0, FALSE);
      CV_EML_IF(0, 1, 6, FALSE);
    }
  }

  CV_EML_FOR(0, 1, 1, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 72);
  for (c4_i29 = 0; c4_i29 < 3; c4_i29++) {
    c4_b_p_o[c4_i29] = c4_p_o[c4_i29];
  }

  for (c4_i30 = 0; c4_i30 < 3; c4_i30++) {
    c4_c_eta[c4_i30] = c4_eta[c4_i30];
  }

  for (c4_i31 = 0; c4_i31 < 2; c4_i31++) {
    c4_c_target[c4_i31] = c4_target[c4_i31];
  }

  c4_ObstacleInPath = c4_ObstacleInpath(chartInstance, c4_b_p_o, c4_d, c4_c_eta,
    c4_c_target);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 73);
  c4_headingObstacle = c4_atan2(chartInstance, c4_V_obs[1], c4_V_obs[0]);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 81);
  guard1 = FALSE;
  guard2 = FALSE;
  guard3 = FALSE;
  if (CV_EML_COND(0, 1, 2, c4_CollisionThreat == 1.0)) {
    guard3 = TRUE;
  } else if (CV_EML_COND(0, 1, 3, c4_ObstacleInPath == 1.0)) {
    guard3 = TRUE;
  } else {
    guard2 = TRUE;
  }

  if (guard3 == TRUE) {
    if (CV_EML_COND(0, 1, 4, c4_p_o[2] == 1.0)) {
      for (c4_i32 = 0; c4_i32 < 3; c4_i32++) {
        c4_c_v_vessel[c4_i32] = c4_v_vessel[c4_i32];
      }

      if (CV_EML_COND(0, 1, 5, c4_c_norm(chartInstance, c4_c_v_vessel) > 0.1)) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 7, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 82);
        c4_threat = 1.0;
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 84);
        for (c4_i33 = 0; c4_i33 < 2; c4_i33++) {
          c4_V_obstacle[c4_i33] = c4_V_obs[c4_i33];
        }

        sf_debug_symbol_scope_push_eml(0U, 5U, 5U, c4_d_debug_family_names,
          c4_b_debug_family_var_map);
        sf_debug_symbol_scope_add_eml_importable(&c4_b_nargin, 0U,
          c4_j_sf_marshallOut, c4_g_sf_marshallIn);
        sf_debug_symbol_scope_add_eml_importable(&c4_b_nargout, 1U,
          c4_j_sf_marshallOut, c4_g_sf_marshallIn);
        sf_debug_symbol_scope_add_eml_importable(c4_V_obstacle, 2U,
          c4_e_sf_marshallOut, c4_e_sf_marshallIn);
        sf_debug_symbol_scope_add_eml_importable(&c4_NewDiraction, 3U,
          c4_j_sf_marshallOut, c4_g_sf_marshallIn);
        sf_debug_symbol_scope_add_eml_importable(chartInstance->c4_lastVelocity,
          4U, c4_m_sf_marshallOut, c4_l_sf_marshallIn);
        CV_EML_FCN(0, 6);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, MAX_uint8_T);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 257);
        if (CV_EML_IF(0, 1, 25, !chartInstance->c4_lastVelocity_not_empty)) {
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 259);
          for (c4_i34 = 0; c4_i34 < 2; c4_i34++) {
            chartInstance->c4_lastVelocity[c4_i34] = 0.0;
          }

          chartInstance->c4_lastVelocity_not_empty = TRUE;
        }

        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 263);
        for (c4_i35 = 0; c4_i35 < 2; c4_i35++) {
          c4_b_V_obstacle[c4_i35] = c4_V_obstacle[c4_i35] -
            chartInstance->c4_lastVelocity[c4_i35];
        }

        if (CV_EML_IF(0, 1, 26, c4_b_norm(chartInstance, c4_b_V_obstacle) > 0.1))
        {
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 264);
          c4_NewDiraction = 1.0;
        } else {
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 266);
          c4_NewDiraction = 0.0;
        }

        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 268);
        for (c4_i36 = 0; c4_i36 < 2; c4_i36++) {
          chartInstance->c4_lastVelocity[c4_i36] = c4_V_obstacle[c4_i36];
        }

        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -268);
        sf_debug_symbol_scope_pop();
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 85);
        if (CV_EML_IF(0, 1, 8, c4_NewDiraction == 1.0)) {
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 87);
          for (c4_i37 = 0; c4_i37 < 2; c4_i37++) {
            c4_b_V_obs[c4_i37] = c4_V_obs[c4_i37];
          }

          for (c4_i38 = 0; c4_i38 < 2; c4_i38++) {
            c4_d_eta[c4_i38] = c4_eta[c4_i38];
          }

          for (c4_i39 = 0; c4_i39 < 2; c4_i39++) {
            c4_c_p_o[c4_i39] = c4_p_o[c4_i39];
          }

          for (c4_i40 = 0; c4_i40 < 2; c4_i40++) {
            c4_d_target[c4_i40] = c4_target[c4_i40];
          }

          c4_ChooseDirection(chartInstance, c4_b_V_obs, c4_temp_d,
                             c4_heading_vehicle, c4_d_eta, c4_c_p_o, c4_d_target,
                             &c4_b_diractionAround, &c4_b_safetyCircle,
                             c4_b_p_obs, &c4_b_back);
          chartInstance->c4_diractionAround = c4_b_diractionAround;
          chartInstance->c4_safetyCircle = c4_b_safetyCircle;
          for (c4_i41 = 0; c4_i41 < 2; c4_i41++) {
            c4_p_obs[c4_i41] = c4_b_p_obs[c4_i41];
          }

          c4_back = c4_b_back;
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 88);
          c4_hoistedGlobal = chartInstance->c4_safetyCircle;
          c4_A = c4_hoistedGlobal;
          c4_B = c4_temp_d;
          c4_x = c4_A;
          c4_y = c4_B;
          c4_b_x = c4_x;
          c4_b_y = c4_y;
          chartInstance->c4_increaseSafetyCircle = c4_b_x / c4_b_y;
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 89);
          chartInstance->c4_backSituation = c4_back;
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 90);
          for (c4_i42 = 0; c4_i42 < 2; c4_i42++) {
            c4_p_o[c4_i42] = c4_p_obs[c4_i42];
          }
        } else {
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 91);
          for (c4_i43 = 0; c4_i43 < 2; c4_i43++) {
            c4_c_V_obs[c4_i43] = c4_V_obs[c4_i43];
          }

          if (CV_EML_IF(0, 1, 9, c4_b_norm(chartInstance, c4_c_V_obs) < 0.1)) {
            _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 92);
            chartInstance->c4_safetyCircle = c4_temp_d;
          }
        }

        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 96);
        guard4 = FALSE;
        if (CV_EML_COND(0, 1, 6, chartInstance->c4_backSituation == 1.0)) {
          for (c4_i44 = 0; c4_i44 < 2; c4_i44++) {
            c4_e_eta[c4_i44] = c4_eta[c4_i44] - c4_target[c4_i44];
          }

          for (c4_i45 = 0; c4_i45 < 2; c4_i45++) {
            c4_d_p_o[c4_i45] = c4_p_o[c4_i45] - c4_target[c4_i45];
          }

          if (CV_EML_COND(0, 1, 7, c4_norm(chartInstance, c4_e_eta) < c4_norm
                          (chartInstance, c4_d_p_o))) {
            CV_EML_MCDC(0, 1, 2, TRUE);
            CV_EML_IF(0, 1, 10, TRUE);
            _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 97);
            c4_c_x = c4_headingObstacle;
            c4_d_x = c4_c_x;
            c4_d_x = muDoubleScalarCos(c4_d_x);
            c4_e_x = c4_headingObstacle;
            c4_f_x = c4_e_x;
            c4_f_x = muDoubleScalarSin(c4_f_x);
            for (c4_i46 = 0; c4_i46 < 2; c4_i46++) {
              c4_e_p_o[c4_i46] = c4_p_o[c4_i46] - c4_eta[c4_i46];
            }

            c4_d0 = c4_norm(chartInstance, c4_e_p_o);
            c4_g_x[0] = c4_d_x;
            c4_g_x[1] = c4_f_x;
            for (c4_i47 = 0; c4_i47 < 2; c4_i47++) {
              c4_p_o[c4_i47] = c4_eta[c4_i47] + c4_d0 * c4_g_x[c4_i47];
            }

            _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 98);
            c4_a = c4_temp_d;
            chartInstance->c4_safetyCircle = c4_a * 1.5;
          } else {
            guard4 = TRUE;
          }
        } else {
          guard4 = TRUE;
        }

        if (guard4 == TRUE) {
          CV_EML_MCDC(0, 1, 2, FALSE);
          CV_EML_IF(0, 1, 10, FALSE);
        }
      } else {
        guard1 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 1, FALSE);
    CV_EML_IF(0, 1, 7, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 102);
    c4_threat = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 106);
  for (c4_i48 = 0; c4_i48 < 2; c4_i48++) {
    c4_f_p_o[c4_i48] = c4_p_o[c4_i48];
  }

  c4_f_p_o[2] = chartInstance->c4_safetyCircle;
  c4_f_p_o[3] = chartInstance->c4_increaseSafetyCircle;
  c4_f_p_o[4] = c4_threat;
  c4_f_p_o[5] = chartInstance->c4_diractionAround;
  c4_f_p_o[6] = c4_p_o[2];
  for (c4_i49 = 0; c4_i49 < 7; c4_i49++) {
    c4_obstacleToCollisionAvoidance[c4_i49] = c4_f_p_o[c4_i49];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -106);
  sf_debug_symbol_scope_pop();
  for (c4_i50 = 0; c4_i50 < 7; c4_i50++) {
    (*c4_b_obstacleToCollisionAvoidance)[c4_i50] =
      c4_obstacleToCollisionAvoidance[c4_i50];
  }

  for (c4_i51 = 0; c4_i51 < 2; c4_i51++) {
    (*c4_d_V_obs)[c4_i51] = c4_V_obs[c4_i51];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
}

static void initSimStructsc4_NSB_vehicle_simulator
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  if (!chartInstance->c4_backSituation_not_empty) {
    sf_mex_assign(&c4_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_backSituation, const char_T *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_backSituation),
    &c4_thisId);
  sf_mex_destroy(&c4_b_backSituation);
  return c4_y;
}

static real_T c4_b_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d1;
  if (mxIsEmpty(c4_u)) {
    chartInstance->c4_backSituation_not_empty = FALSE;
  } else {
    chartInstance->c4_backSituation_not_empty = TRUE;
    sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d1, 1, 0, 0U, 0, 0U, 0);
    c4_y = c4_d1;
  }

  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_backSituation;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_b_backSituation = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_backSituation),
    &c4_thisId);
  sf_mex_destroy(&c4_b_backSituation);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  if (!chartInstance->c4_safetyCircle_not_empty) {
    sf_mex_assign(&c4_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_c_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_safetyCircle, const char_T *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_safetyCircle),
    &c4_thisId);
  sf_mex_destroy(&c4_b_safetyCircle);
  return c4_y;
}

static real_T c4_d_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d2;
  if (mxIsEmpty(c4_u)) {
    chartInstance->c4_safetyCircle_not_empty = FALSE;
  } else {
    chartInstance->c4_safetyCircle_not_empty = TRUE;
    sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d2, 1, 0, 0U, 0, 0U, 0);
    c4_y = c4_d2;
  }

  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_safetyCircle;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_b_safetyCircle = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_safetyCircle),
    &c4_thisId);
  sf_mex_destroy(&c4_b_safetyCircle);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  if (!chartInstance->c4_increaseSafetyCircle_not_empty) {
    sf_mex_assign(&c4_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_e_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_increaseSafetyCircle, const char_T
  *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c4_b_increaseSafetyCircle), &c4_thisId);
  sf_mex_destroy(&c4_b_increaseSafetyCircle);
  return c4_y;
}

static real_T c4_f_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d3;
  if (mxIsEmpty(c4_u)) {
    chartInstance->c4_increaseSafetyCircle_not_empty = FALSE;
  } else {
    chartInstance->c4_increaseSafetyCircle_not_empty = TRUE;
    sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d3, 1, 0, 0U, 0, 0U, 0);
    c4_y = c4_d3;
  }

  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_increaseSafetyCircle;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_b_increaseSafetyCircle = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c4_b_increaseSafetyCircle), &c4_thisId);
  sf_mex_destroy(&c4_b_increaseSafetyCircle);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_d_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  if (!chartInstance->c4_diractionAround_not_empty) {
    sf_mex_assign(&c4_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_g_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_diractionAround, const char_T
  *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_diractionAround),
    &c4_thisId);
  sf_mex_destroy(&c4_b_diractionAround);
  return c4_y;
}

static real_T c4_h_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d4;
  if (mxIsEmpty(c4_u)) {
    chartInstance->c4_diractionAround_not_empty = FALSE;
  } else {
    chartInstance->c4_diractionAround_not_empty = TRUE;
    sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d4, 1, 0, 0U, 0, 0U, 0);
    c4_y = c4_d4;
  }

  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_diractionAround;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_b_diractionAround = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_diractionAround),
    &c4_thisId);
  sf_mex_destroy(&c4_b_diractionAround);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_e_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i52;
  real_T c4_b_inData[2];
  int32_T c4_i53;
  real_T c4_u[2];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i52 = 0; c4_i52 < 2; c4_i52++) {
    c4_b_inData[c4_i52] = (*(real_T (*)[2])c4_inData)[c4_i52];
  }

  for (c4_i53 = 0; c4_i53 < 2; c4_i53++) {
    c4_u[c4_i53] = c4_b_inData[c4_i53];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_i_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_V_obs, const char_T *c4_identifier, real_T
  c4_y[2])
{
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_V_obs), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_V_obs);
}

static void c4_j_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2])
{
  real_T c4_dv3[2];
  int32_T c4_i54;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv3, 1, 0, 0U, 1, 0U, 2, 1, 2);
  for (c4_i54 = 0; c4_i54 < 2; c4_i54++) {
    c4_y[c4_i54] = c4_dv3[c4_i54];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_V_obs;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[2];
  int32_T c4_i55;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_V_obs = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_V_obs), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_V_obs);
  for (c4_i55 = 0; c4_i55 < 2; c4_i55++) {
    (*(real_T (*)[2])c4_outData)[c4_i55] = c4_y[c4_i55];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_f_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i56;
  real_T c4_b_inData[7];
  int32_T c4_i57;
  real_T c4_u[7];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i56 = 0; c4_i56 < 7; c4_i56++) {
    c4_b_inData[c4_i56] = (*(real_T (*)[7])c4_inData)[c4_i56];
  }

  for (c4_i57 = 0; c4_i57 < 7; c4_i57++) {
    c4_u[c4_i57] = c4_b_inData[c4_i57];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 7), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_k_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_obstacleToCollisionAvoidance, const char_T
  *c4_identifier, real_T c4_y[7])
{
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_l_emlrt_marshallIn(chartInstance, sf_mex_dup
                        (c4_obstacleToCollisionAvoidance), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_obstacleToCollisionAvoidance);
}

static void c4_l_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[7])
{
  real_T c4_dv4[7];
  int32_T c4_i58;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv4, 1, 0, 0U, 1, 0U, 1, 7);
  for (c4_i58 = 0; c4_i58 < 7; c4_i58++) {
    c4_y[c4_i58] = c4_dv4[c4_i58];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_obstacleToCollisionAvoidance;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[7];
  int32_T c4_i59;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_obstacleToCollisionAvoidance = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_l_emlrt_marshallIn(chartInstance, sf_mex_dup
                        (c4_obstacleToCollisionAvoidance), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_obstacleToCollisionAvoidance);
  for (c4_i59 = 0; c4_i59 < 7; c4_i59++) {
    (*(real_T (*)[7])c4_outData)[c4_i59] = c4_y[c4_i59];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_g_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i60;
  real_T c4_b_inData[2];
  int32_T c4_i61;
  real_T c4_u[2];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i60 = 0; c4_i60 < 2; c4_i60++) {
    c4_b_inData[c4_i60] = (*(real_T (*)[2])c4_inData)[c4_i60];
  }

  for (c4_i61 = 0; c4_i61 < 2; c4_i61++) {
    c4_u[c4_i61] = c4_b_inData[c4_i61];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static const mxArray *c4_h_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i62;
  real_T c4_b_inData[4];
  int32_T c4_i63;
  real_T c4_u[4];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i62 = 0; c4_i62 < 4; c4_i62++) {
    c4_b_inData[c4_i62] = (*(real_T (*)[4])c4_inData)[c4_i62];
  }

  for (c4_i63 = 0; c4_i63 < 4; c4_i63++) {
    c4_u[c4_i63] = c4_b_inData[c4_i63];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 1, 4), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static const mxArray *c4_i_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i64;
  real_T c4_b_inData[3];
  int32_T c4_i65;
  real_T c4_u[3];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i64 = 0; c4_i64 < 3; c4_i64++) {
    c4_b_inData[c4_i64] = (*(real_T (*)[3])c4_inData)[c4_i64];
  }

  for (c4_i65 = 0; c4_i65 < 3; c4_i65++) {
    c4_u[c4_i65] = c4_b_inData[c4_i65];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static const mxArray *c4_j_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_m_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d5;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d5, 1, 0, 0U, 0, 0U, 0);
  c4_y = c4_d5;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_nargout;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_nargout = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_m_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_nargout), &c4_thisId);
  sf_mex_destroy(&c4_nargout);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static void c4_n_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2])
{
  real_T c4_dv5[2];
  int32_T c4_i66;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv5, 1, 0, 0U, 1, 0U, 1, 2);
  for (c4_i66 = 0; c4_i66 < 2; c4_i66++) {
    c4_y[c4_i66] = c4_dv5[c4_i66];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_p_obs;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[2];
  int32_T c4_i67;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_p_obs = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_p_obs), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_p_obs);
  for (c4_i67 = 0; c4_i67 < 2; c4_i67++) {
    (*(real_T (*)[2])c4_outData)[c4_i67] = c4_y[c4_i67];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static void c4_o_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[3])
{
  real_T c4_dv6[3];
  int32_T c4_i68;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv6, 1, 0, 0U, 1, 0U, 1, 3);
  for (c4_i68 = 0; c4_i68 < 3; c4_i68++) {
    c4_y[c4_i68] = c4_dv6[c4_i68];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_p_o;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[3];
  int32_T c4_i69;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_p_o = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_o_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_p_o), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_p_o);
  for (c4_i69 = 0; c4_i69 < 3; c4_i69++) {
    (*(real_T (*)[3])c4_outData)[c4_i69] = c4_y[c4_i69];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_k_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i70;
  real_T c4_b_inData[51];
  int32_T c4_i71;
  real_T c4_u[51];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i70 = 0; c4_i70 < 51; c4_i70++) {
    c4_b_inData[c4_i70] = (*(real_T (*)[51])c4_inData)[c4_i70];
  }

  for (c4_i71 = 0; c4_i71 < 51; c4_i71++) {
    c4_u[c4_i71] = c4_b_inData[c4_i71];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 1, 51), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_p_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[51])
{
  real_T c4_dv7[51];
  int32_T c4_i72;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv7, 1, 0, 0U, 1, 0U, 2, 1, 51);
  for (c4_i72 = 0; c4_i72 < 51; c4_i72++) {
    c4_y[c4_i72] = c4_dv7[c4_i72];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_j_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_D;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[51];
  int32_T c4_i73;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_D = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_p_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_D), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_D);
  for (c4_i73 = 0; c4_i73 < 51; c4_i73++) {
    (*(real_T (*)[51])c4_outData)[c4_i73] = c4_y[c4_i73];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_l_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i74;
  int32_T c4_i75;
  int32_T c4_i76;
  real_T c4_b_inData[102];
  int32_T c4_i77;
  int32_T c4_i78;
  int32_T c4_i79;
  real_T c4_u[102];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_i74 = 0;
  for (c4_i75 = 0; c4_i75 < 51; c4_i75++) {
    for (c4_i76 = 0; c4_i76 < 2; c4_i76++) {
      c4_b_inData[c4_i76 + c4_i74] = (*(real_T (*)[102])c4_inData)[c4_i76 +
        c4_i74];
    }

    c4_i74 += 2;
  }

  c4_i77 = 0;
  for (c4_i78 = 0; c4_i78 < 51; c4_i78++) {
    for (c4_i79 = 0; c4_i79 < 2; c4_i79++) {
      c4_u[c4_i79 + c4_i77] = c4_b_inData[c4_i79 + c4_i77];
    }

    c4_i77 += 2;
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 2, 51), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_q_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[102])
{
  real_T c4_dv8[102];
  int32_T c4_i80;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv8, 1, 0, 0U, 1, 0U, 2, 2, 51);
  for (c4_i80 = 0; c4_i80 < 102; c4_i80++) {
    c4_y[c4_i80] = c4_dv8[c4_i80];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_k_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_N;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[102];
  int32_T c4_i81;
  int32_T c4_i82;
  int32_T c4_i83;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_N = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_q_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_N), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_N);
  c4_i81 = 0;
  for (c4_i82 = 0; c4_i82 < 51; c4_i82++) {
    for (c4_i83 = 0; c4_i83 < 2; c4_i83++) {
      (*(real_T (*)[102])c4_outData)[c4_i83 + c4_i81] = c4_y[c4_i83 + c4_i81];
    }

    c4_i81 += 2;
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_m_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i84;
  real_T c4_b_inData[2];
  int32_T c4_i85;
  real_T c4_u[2];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i84 = 0; c4_i84 < 2; c4_i84++) {
    c4_b_inData[c4_i84] = (*(real_T (*)[2])c4_inData)[c4_i84];
  }

  for (c4_i85 = 0; c4_i85 < 2; c4_i85++) {
    c4_u[c4_i85] = c4_b_inData[c4_i85];
  }

  c4_y = NULL;
  if (!chartInstance->c4_lastVelocity_not_empty) {
    sf_mex_assign(&c4_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  }

  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_r_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_lastVelocity, const char_T *c4_identifier,
  real_T c4_y[2])
{
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_s_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_lastVelocity), &c4_thisId,
                        c4_y);
  sf_mex_destroy(&c4_b_lastVelocity);
}

static void c4_s_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[2])
{
  real_T c4_dv9[2];
  int32_T c4_i86;
  if (mxIsEmpty(c4_u)) {
    chartInstance->c4_lastVelocity_not_empty = FALSE;
  } else {
    chartInstance->c4_lastVelocity_not_empty = TRUE;
    sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv9, 1, 0, 0U, 1, 0U, 2, 1,
                  2);
    for (c4_i86 = 0; c4_i86 < 2; c4_i86++) {
      c4_y[c4_i86] = c4_dv9[c4_i86];
    }
  }

  sf_mex_destroy(&c4_u);
}

static void c4_l_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_lastVelocity;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[2];
  int32_T c4_i87;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_b_lastVelocity = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_s_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_lastVelocity), &c4_thisId,
                        c4_y);
  sf_mex_destroy(&c4_b_lastVelocity);
  for (c4_i87 = 0; c4_i87 < 2; c4_i87++) {
    (*(real_T (*)[2])c4_outData)[c4_i87] = c4_y[c4_i87];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_n_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i88;
  int32_T c4_i89;
  int32_T c4_i90;
  real_T c4_b_inData[4];
  int32_T c4_i91;
  int32_T c4_i92;
  int32_T c4_i93;
  real_T c4_u[4];
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_i88 = 0;
  for (c4_i89 = 0; c4_i89 < 2; c4_i89++) {
    for (c4_i90 = 0; c4_i90 < 2; c4_i90++) {
      c4_b_inData[c4_i90 + c4_i88] = (*(real_T (*)[4])c4_inData)[c4_i90 + c4_i88];
    }

    c4_i88 += 2;
  }

  c4_i91 = 0;
  for (c4_i92 = 0; c4_i92 < 2; c4_i92++) {
    for (c4_i93 = 0; c4_i93 < 2; c4_i93++) {
      c4_u[c4_i93 + c4_i91] = c4_b_inData[c4_i93 + c4_i91];
    }

    c4_i91 += 2;
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_t_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId,
  real_T c4_y[4])
{
  real_T c4_dv10[4];
  int32_T c4_i94;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv10, 1, 0, 0U, 1, 0U, 2, 2, 2);
  for (c4_i94 = 0; c4_i94 < 4; c4_i94++) {
    c4_y[c4_i94] = c4_dv10[c4_i94];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_m_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_R_matrix;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[4];
  int32_T c4_i95;
  int32_T c4_i96;
  int32_T c4_i97;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_R_matrix = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_t_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_R_matrix), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_R_matrix);
  c4_i95 = 0;
  for (c4_i96 = 0; c4_i96 < 2; c4_i96++) {
    for (c4_i97 = 0; c4_i97 < 2; c4_i97++) {
      (*(real_T (*)[4])c4_outData)[c4_i97 + c4_i95] = c4_y[c4_i97 + c4_i95];
    }

    c4_i95 += 2;
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

const mxArray *sf_c4_NSB_vehicle_simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo;
  c4_ResolvedFunctionInfo c4_info[74];
  c4_ResolvedFunctionInfo (*c4_b_info)[74];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i98;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_nameCaptureInfo = NULL;
  c4_info_helper(c4_info);
  c4_b_info = (c4_ResolvedFunctionInfo (*)[74])c4_info;
  (*c4_b_info)[64].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c4_b_info)[64].name = "power";
  (*c4_b_info)[64].dominantType = "double";
  (*c4_b_info)[64].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c4_b_info)[64].fileTimeLo = 1336522096U;
  (*c4_b_info)[64].fileTimeHi = 0U;
  (*c4_b_info)[64].mFileTimeLo = 0U;
  (*c4_b_info)[64].mFileTimeHi = 0U;
  (*c4_b_info)[65].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c4_b_info)[65].name = "eml_index_class";
  (*c4_b_info)[65].dominantType = "";
  (*c4_b_info)[65].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  (*c4_b_info)[65].fileTimeLo = 1323170578U;
  (*c4_b_info)[65].fileTimeHi = 0U;
  (*c4_b_info)[65].mFileTimeLo = 0U;
  (*c4_b_info)[65].mFileTimeHi = 0U;
  (*c4_b_info)[66].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c4_b_info)[66].name = "eml_scalar_eg";
  (*c4_b_info)[66].dominantType = "double";
  (*c4_b_info)[66].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c4_b_info)[66].fileTimeLo = 1286818796U;
  (*c4_b_info)[66].fileTimeHi = 0U;
  (*c4_b_info)[66].mFileTimeLo = 0U;
  (*c4_b_info)[66].mFileTimeHi = 0U;
  (*c4_b_info)[67].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c4_b_info)[67].name = "eml_xgemm";
  (*c4_b_info)[67].dominantType = "char";
  (*c4_b_info)[67].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  (*c4_b_info)[67].fileTimeLo = 1299076772U;
  (*c4_b_info)[67].fileTimeHi = 0U;
  (*c4_b_info)[67].mFileTimeLo = 0U;
  (*c4_b_info)[67].mFileTimeHi = 0U;
  (*c4_b_info)[68].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  (*c4_b_info)[68].name = "eml_blas_inline";
  (*c4_b_info)[68].dominantType = "";
  (*c4_b_info)[68].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  (*c4_b_info)[68].fileTimeLo = 1299076768U;
  (*c4_b_info)[68].fileTimeHi = 0U;
  (*c4_b_info)[68].mFileTimeLo = 0U;
  (*c4_b_info)[68].mFileTimeHi = 0U;
  (*c4_b_info)[69].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  (*c4_b_info)[69].name = "mtimes";
  (*c4_b_info)[69].dominantType = "double";
  (*c4_b_info)[69].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c4_b_info)[69].fileTimeLo = 1289519692U;
  (*c4_b_info)[69].fileTimeHi = 0U;
  (*c4_b_info)[69].mFileTimeLo = 0U;
  (*c4_b_info)[69].mFileTimeHi = 0U;
  (*c4_b_info)[70].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c4_b_info)[70].name = "eml_index_class";
  (*c4_b_info)[70].dominantType = "";
  (*c4_b_info)[70].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  (*c4_b_info)[70].fileTimeLo = 1323170578U;
  (*c4_b_info)[70].fileTimeHi = 0U;
  (*c4_b_info)[70].mFileTimeLo = 0U;
  (*c4_b_info)[70].mFileTimeHi = 0U;
  (*c4_b_info)[71].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c4_b_info)[71].name = "eml_scalar_eg";
  (*c4_b_info)[71].dominantType = "double";
  (*c4_b_info)[71].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c4_b_info)[71].fileTimeLo = 1286818796U;
  (*c4_b_info)[71].fileTimeHi = 0U;
  (*c4_b_info)[71].mFileTimeLo = 0U;
  (*c4_b_info)[71].mFileTimeHi = 0U;
  (*c4_b_info)[72].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c4_b_info)[72].name = "eml_refblas_xgemm";
  (*c4_b_info)[72].dominantType = "char";
  (*c4_b_info)[72].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  (*c4_b_info)[72].fileTimeLo = 1299076774U;
  (*c4_b_info)[72].fileTimeHi = 0U;
  (*c4_b_info)[72].mFileTimeLo = 0U;
  (*c4_b_info)[72].mFileTimeHi = 0U;
  (*c4_b_info)[73].context = "";
  (*c4_b_info)[73].name = "abs";
  (*c4_b_info)[73].dominantType = "double";
  (*c4_b_info)[73].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c4_b_info)[73].fileTimeLo = 1286818694U;
  (*c4_b_info)[73].fileTimeHi = 0U;
  (*c4_b_info)[73].mFileTimeLo = 0U;
  (*c4_b_info)[73].mFileTimeHi = 0U;
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 74), FALSE);
  for (c4_i98 = 0; c4_i98 < 74; c4_i98++) {
    c4_r0 = &c4_info[c4_i98];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context", "nameCaptureInfo",
                    c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name", "nameCaptureInfo", c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved", "nameCaptureInfo",
                    c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c4_i98);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c4_i98);
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c4_nameCaptureInfo);
  return c4_nameCaptureInfo;
}

static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[74])
{
  c4_info[0].context = "";
  c4_info[0].name = "norm";
  c4_info[0].dominantType = "double";
  c4_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c4_info[0].fileTimeLo = 1336522094U;
  c4_info[0].fileTimeHi = 0U;
  c4_info[0].mFileTimeLo = 0U;
  c4_info[0].mFileTimeHi = 0U;
  c4_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c4_info[1].name = "eml_index_class";
  c4_info[1].dominantType = "";
  c4_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[1].fileTimeLo = 1323170578U;
  c4_info[1].fileTimeHi = 0U;
  c4_info[1].mFileTimeLo = 0U;
  c4_info[1].mFileTimeHi = 0U;
  c4_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c4_info[2].name = "eml_xnrm2";
  c4_info[2].dominantType = "double";
  c4_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c4_info[2].fileTimeLo = 1299076776U;
  c4_info[2].fileTimeHi = 0U;
  c4_info[2].mFileTimeLo = 0U;
  c4_info[2].mFileTimeHi = 0U;
  c4_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c4_info[3].name = "eml_blas_inline";
  c4_info[3].dominantType = "";
  c4_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c4_info[3].fileTimeLo = 1299076768U;
  c4_info[3].fileTimeHi = 0U;
  c4_info[3].mFileTimeLo = 0U;
  c4_info[3].mFileTimeHi = 0U;
  c4_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c4_info[4].name = "eml_index_class";
  c4_info[4].dominantType = "";
  c4_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[4].fileTimeLo = 1323170578U;
  c4_info[4].fileTimeHi = 0U;
  c4_info[4].mFileTimeLo = 0U;
  c4_info[4].mFileTimeHi = 0U;
  c4_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c4_info[5].name = "eml_refblas_xnrm2";
  c4_info[5].dominantType = "double";
  c4_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[5].fileTimeLo = 1299076784U;
  c4_info[5].fileTimeHi = 0U;
  c4_info[5].mFileTimeLo = 0U;
  c4_info[5].mFileTimeHi = 0U;
  c4_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[6].name = "realmin";
  c4_info[6].dominantType = "char";
  c4_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c4_info[6].fileTimeLo = 1307651242U;
  c4_info[6].fileTimeHi = 0U;
  c4_info[6].mFileTimeLo = 0U;
  c4_info[6].mFileTimeHi = 0U;
  c4_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c4_info[7].name = "eml_realmin";
  c4_info[7].dominantType = "char";
  c4_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c4_info[7].fileTimeLo = 1307651244U;
  c4_info[7].fileTimeHi = 0U;
  c4_info[7].mFileTimeLo = 0U;
  c4_info[7].mFileTimeHi = 0U;
  c4_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c4_info[8].name = "eml_float_model";
  c4_info[8].dominantType = "char";
  c4_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c4_info[8].fileTimeLo = 1326727996U;
  c4_info[8].fileTimeHi = 0U;
  c4_info[8].mFileTimeLo = 0U;
  c4_info[8].mFileTimeHi = 0U;
  c4_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[9].name = "eml_index_class";
  c4_info[9].dominantType = "";
  c4_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[9].fileTimeLo = 1323170578U;
  c4_info[9].fileTimeHi = 0U;
  c4_info[9].mFileTimeLo = 0U;
  c4_info[9].mFileTimeHi = 0U;
  c4_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[10].name = "eml_index_minus";
  c4_info[10].dominantType = "double";
  c4_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c4_info[10].fileTimeLo = 1286818778U;
  c4_info[10].fileTimeHi = 0U;
  c4_info[10].mFileTimeLo = 0U;
  c4_info[10].mFileTimeHi = 0U;
  c4_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c4_info[11].name = "eml_index_class";
  c4_info[11].dominantType = "";
  c4_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[11].fileTimeLo = 1323170578U;
  c4_info[11].fileTimeHi = 0U;
  c4_info[11].mFileTimeLo = 0U;
  c4_info[11].mFileTimeHi = 0U;
  c4_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[12].name = "eml_index_times";
  c4_info[12].dominantType = "coder.internal.indexInt";
  c4_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c4_info[12].fileTimeLo = 1286818780U;
  c4_info[12].fileTimeHi = 0U;
  c4_info[12].mFileTimeLo = 0U;
  c4_info[12].mFileTimeHi = 0U;
  c4_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c4_info[13].name = "eml_index_class";
  c4_info[13].dominantType = "";
  c4_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[13].fileTimeLo = 1323170578U;
  c4_info[13].fileTimeHi = 0U;
  c4_info[13].mFileTimeLo = 0U;
  c4_info[13].mFileTimeHi = 0U;
  c4_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[14].name = "eml_index_plus";
  c4_info[14].dominantType = "coder.internal.indexInt";
  c4_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c4_info[14].fileTimeLo = 1286818778U;
  c4_info[14].fileTimeHi = 0U;
  c4_info[14].mFileTimeLo = 0U;
  c4_info[14].mFileTimeHi = 0U;
  c4_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c4_info[15].name = "eml_index_class";
  c4_info[15].dominantType = "";
  c4_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[15].fileTimeLo = 1323170578U;
  c4_info[15].fileTimeHi = 0U;
  c4_info[15].mFileTimeLo = 0U;
  c4_info[15].mFileTimeHi = 0U;
  c4_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[16].name = "eml_int_forloop_overflow_check";
  c4_info[16].dominantType = "";
  c4_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c4_info[16].fileTimeLo = 1332168672U;
  c4_info[16].fileTimeHi = 0U;
  c4_info[16].mFileTimeLo = 0U;
  c4_info[16].mFileTimeHi = 0U;
  c4_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c4_info[17].name = "intmax";
  c4_info[17].dominantType = "char";
  c4_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c4_info[17].fileTimeLo = 1311255316U;
  c4_info[17].fileTimeHi = 0U;
  c4_info[17].mFileTimeLo = 0U;
  c4_info[17].mFileTimeHi = 0U;
  c4_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c4_info[18].name = "abs";
  c4_info[18].dominantType = "double";
  c4_info[18].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[18].fileTimeLo = 1286818694U;
  c4_info[18].fileTimeHi = 0U;
  c4_info[18].mFileTimeLo = 0U;
  c4_info[18].mFileTimeHi = 0U;
  c4_info[19].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[19].name = "eml_scalar_abs";
  c4_info[19].dominantType = "double";
  c4_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c4_info[19].fileTimeLo = 1286818712U;
  c4_info[19].fileTimeHi = 0U;
  c4_info[19].mFileTimeLo = 0U;
  c4_info[19].mFileTimeHi = 0U;
  c4_info[20].context = "";
  c4_info[20].name = "length";
  c4_info[20].dominantType = "double";
  c4_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c4_info[20].fileTimeLo = 1303146206U;
  c4_info[20].fileTimeHi = 0U;
  c4_info[20].mFileTimeLo = 0U;
  c4_info[20].mFileTimeHi = 0U;
  c4_info[21].context = "";
  c4_info[21].name = "atan2";
  c4_info[21].dominantType = "double";
  c4_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[21].fileTimeLo = 1286818704U;
  c4_info[21].fileTimeHi = 0U;
  c4_info[21].mFileTimeLo = 0U;
  c4_info[21].mFileTimeHi = 0U;
  c4_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[22].name = "eml_scalar_eg";
  c4_info[22].dominantType = "double";
  c4_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c4_info[22].fileTimeLo = 1286818796U;
  c4_info[22].fileTimeHi = 0U;
  c4_info[22].mFileTimeLo = 0U;
  c4_info[22].mFileTimeHi = 0U;
  c4_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[23].name = "eml_scalexp_alloc";
  c4_info[23].dominantType = "double";
  c4_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c4_info[23].fileTimeLo = 1330608434U;
  c4_info[23].fileTimeHi = 0U;
  c4_info[23].mFileTimeLo = 0U;
  c4_info[23].mFileTimeHi = 0U;
  c4_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c4_info[24].name = "eml_scalar_atan2";
  c4_info[24].dominantType = "double";
  c4_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c4_info[24].fileTimeLo = 1286818720U;
  c4_info[24].fileTimeHi = 0U;
  c4_info[24].mFileTimeLo = 0U;
  c4_info[24].mFileTimeHi = 0U;
  c4_info[25].context = "";
  c4_info[25].name = "colon";
  c4_info[25].dominantType = "double";
  c4_info[25].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m";
  c4_info[25].fileTimeLo = 1311255318U;
  c4_info[25].fileTimeHi = 0U;
  c4_info[25].mFileTimeLo = 0U;
  c4_info[25].mFileTimeHi = 0U;
  c4_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!is_flint_colon";
  c4_info[26].name = "isfinite";
  c4_info[26].dominantType = "double";
  c4_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c4_info[26].fileTimeLo = 1286818758U;
  c4_info[26].fileTimeHi = 0U;
  c4_info[26].mFileTimeLo = 0U;
  c4_info[26].mFileTimeHi = 0U;
  c4_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c4_info[27].name = "isinf";
  c4_info[27].dominantType = "double";
  c4_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c4_info[27].fileTimeLo = 1286818760U;
  c4_info[27].fileTimeHi = 0U;
  c4_info[27].mFileTimeLo = 0U;
  c4_info[27].mFileTimeHi = 0U;
  c4_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c4_info[28].name = "isnan";
  c4_info[28].dominantType = "double";
  c4_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c4_info[28].fileTimeLo = 1286818760U;
  c4_info[28].fileTimeHi = 0U;
  c4_info[28].mFileTimeLo = 0U;
  c4_info[28].mFileTimeHi = 0U;
  c4_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!is_flint_colon";
  c4_info[29].name = "floor";
  c4_info[29].dominantType = "double";
  c4_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[29].fileTimeLo = 1286818742U;
  c4_info[29].fileTimeHi = 0U;
  c4_info[29].mFileTimeLo = 0U;
  c4_info[29].mFileTimeHi = 0U;
  c4_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[30].name = "eml_scalar_floor";
  c4_info[30].dominantType = "double";
  c4_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c4_info[30].fileTimeLo = 1286818726U;
  c4_info[30].fileTimeHi = 0U;
  c4_info[30].mFileTimeLo = 0U;
  c4_info[30].mFileTimeHi = 0U;
  c4_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!maxabs";
  c4_info[31].name = "abs";
  c4_info[31].dominantType = "double";
  c4_info[31].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[31].fileTimeLo = 1286818694U;
  c4_info[31].fileTimeHi = 0U;
  c4_info[31].mFileTimeLo = 0U;
  c4_info[31].mFileTimeHi = 0U;
  c4_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!is_flint_colon";
  c4_info[32].name = "eps";
  c4_info[32].dominantType = "double";
  c4_info[32].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c4_info[32].fileTimeLo = 1326727996U;
  c4_info[32].fileTimeHi = 0U;
  c4_info[32].mFileTimeLo = 0U;
  c4_info[32].mFileTimeHi = 0U;
  c4_info[33].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c4_info[33].name = "eml_mantissa_nbits";
  c4_info[33].dominantType = "char";
  c4_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_mantissa_nbits.m";
  c4_info[33].fileTimeLo = 1307651242U;
  c4_info[33].fileTimeHi = 0U;
  c4_info[33].mFileTimeLo = 0U;
  c4_info[33].mFileTimeHi = 0U;
  c4_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_mantissa_nbits.m";
  c4_info[34].name = "eml_float_model";
  c4_info[34].dominantType = "char";
  c4_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c4_info[34].fileTimeLo = 1326727996U;
  c4_info[34].fileTimeHi = 0U;
  c4_info[34].mFileTimeLo = 0U;
  c4_info[34].mFileTimeHi = 0U;
  c4_info[35].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c4_info[35].name = "eml_realmin";
  c4_info[35].dominantType = "char";
  c4_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin.m";
  c4_info[35].fileTimeLo = 1307651244U;
  c4_info[35].fileTimeHi = 0U;
  c4_info[35].mFileTimeLo = 0U;
  c4_info[35].mFileTimeHi = 0U;
  c4_info[36].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c4_info[36].name = "eml_realmin_denormal";
  c4_info[36].dominantType = "char";
  c4_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin_denormal.m";
  c4_info[36].fileTimeLo = 1326727998U;
  c4_info[36].fileTimeHi = 0U;
  c4_info[36].mFileTimeLo = 0U;
  c4_info[36].mFileTimeHi = 0U;
  c4_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmin_denormal.m";
  c4_info[37].name = "eml_float_model";
  c4_info[37].dominantType = "char";
  c4_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c4_info[37].fileTimeLo = 1326727996U;
  c4_info[37].fileTimeHi = 0U;
  c4_info[37].mFileTimeLo = 0U;
  c4_info[37].mFileTimeHi = 0U;
  c4_info[38].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c4_info[38].name = "abs";
  c4_info[38].dominantType = "double";
  c4_info[38].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c4_info[38].fileTimeLo = 1286818694U;
  c4_info[38].fileTimeHi = 0U;
  c4_info[38].mFileTimeLo = 0U;
  c4_info[38].mFileTimeHi = 0U;
  c4_info[39].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c4_info[39].name = "isfinite";
  c4_info[39].dominantType = "double";
  c4_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c4_info[39].fileTimeLo = 1286818758U;
  c4_info[39].fileTimeHi = 0U;
  c4_info[39].mFileTimeLo = 0U;
  c4_info[39].mFileTimeHi = 0U;
  c4_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!checkrange";
  c4_info[40].name = "realmax";
  c4_info[40].dominantType = "char";
  c4_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c4_info[40].fileTimeLo = 1307651242U;
  c4_info[40].fileTimeHi = 0U;
  c4_info[40].mFileTimeLo = 0U;
  c4_info[40].mFileTimeHi = 0U;
  c4_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c4_info[41].name = "eml_realmax";
  c4_info[41].dominantType = "char";
  c4_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c4_info[41].fileTimeLo = 1326727996U;
  c4_info[41].fileTimeHi = 0U;
  c4_info[41].mFileTimeLo = 0U;
  c4_info[41].mFileTimeHi = 0U;
  c4_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c4_info[42].name = "eml_float_model";
  c4_info[42].dominantType = "char";
  c4_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c4_info[42].fileTimeLo = 1326727996U;
  c4_info[42].fileTimeHi = 0U;
  c4_info[42].mFileTimeLo = 0U;
  c4_info[42].mFileTimeHi = 0U;
  c4_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c4_info[43].name = "mtimes";
  c4_info[43].dominantType = "double";
  c4_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[43].fileTimeLo = 1289519692U;
  c4_info[43].fileTimeHi = 0U;
  c4_info[43].mFileTimeLo = 0U;
  c4_info[43].mFileTimeHi = 0U;
  c4_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!eml_flint_colon";
  c4_info[44].name = "mrdivide";
  c4_info[44].dominantType = "double";
  c4_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[44].fileTimeLo = 1342810944U;
  c4_info[44].fileTimeHi = 0U;
  c4_info[44].mFileTimeLo = 1319729966U;
  c4_info[44].mFileTimeHi = 0U;
  c4_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[45].name = "rdivide";
  c4_info[45].dominantType = "double";
  c4_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[45].fileTimeLo = 1286818844U;
  c4_info[45].fileTimeHi = 0U;
  c4_info[45].mFileTimeLo = 0U;
  c4_info[45].mFileTimeHi = 0U;
  c4_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[46].name = "eml_div";
  c4_info[46].dominantType = "double";
  c4_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c4_info[46].fileTimeLo = 1313347810U;
  c4_info[46].fileTimeHi = 0U;
  c4_info[46].mFileTimeLo = 0U;
  c4_info[46].mFileTimeHi = 0U;
  c4_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!eml_flint_colon";
  c4_info[47].name = "floor";
  c4_info[47].dominantType = "double";
  c4_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[47].fileTimeLo = 1286818742U;
  c4_info[47].fileTimeHi = 0U;
  c4_info[47].mFileTimeLo = 0U;
  c4_info[47].mFileTimeHi = 0U;
  c4_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!eml_flint_colon";
  c4_info[48].name = "eml_index_class";
  c4_info[48].dominantType = "";
  c4_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[48].fileTimeLo = 1323170578U;
  c4_info[48].fileTimeHi = 0U;
  c4_info[48].mFileTimeLo = 0U;
  c4_info[48].mFileTimeHi = 0U;
  c4_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!eml_flint_colon";
  c4_info[49].name = "intmax";
  c4_info[49].dominantType = "char";
  c4_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c4_info[49].fileTimeLo = 1311255316U;
  c4_info[49].fileTimeHi = 0U;
  c4_info[49].mFileTimeLo = 0U;
  c4_info[49].mFileTimeHi = 0U;
  c4_info[50].context = "";
  c4_info[50].name = "mtimes";
  c4_info[50].dominantType = "double";
  c4_info[50].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[50].fileTimeLo = 1289519692U;
  c4_info[50].fileTimeHi = 0U;
  c4_info[50].mFileTimeLo = 0U;
  c4_info[50].mFileTimeHi = 0U;
  c4_info[51].context = "";
  c4_info[51].name = "cos";
  c4_info[51].dominantType = "double";
  c4_info[51].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c4_info[51].fileTimeLo = 1286818706U;
  c4_info[51].fileTimeHi = 0U;
  c4_info[51].mFileTimeLo = 0U;
  c4_info[51].mFileTimeHi = 0U;
  c4_info[52].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c4_info[52].name = "eml_scalar_cos";
  c4_info[52].dominantType = "double";
  c4_info[52].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c4_info[52].fileTimeLo = 1286818722U;
  c4_info[52].fileTimeHi = 0U;
  c4_info[52].mFileTimeLo = 0U;
  c4_info[52].mFileTimeHi = 0U;
  c4_info[53].context = "";
  c4_info[53].name = "sin";
  c4_info[53].dominantType = "double";
  c4_info[53].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c4_info[53].fileTimeLo = 1286818750U;
  c4_info[53].fileTimeHi = 0U;
  c4_info[53].mFileTimeLo = 0U;
  c4_info[53].mFileTimeHi = 0U;
  c4_info[54].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c4_info[54].name = "eml_scalar_sin";
  c4_info[54].dominantType = "double";
  c4_info[54].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c4_info[54].fileTimeLo = 1286818736U;
  c4_info[54].fileTimeHi = 0U;
  c4_info[54].mFileTimeLo = 0U;
  c4_info[54].mFileTimeHi = 0U;
  c4_info[55].context = "";
  c4_info[55].name = "power";
  c4_info[55].dominantType = "double";
  c4_info[55].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c4_info[55].fileTimeLo = 1336522096U;
  c4_info[55].fileTimeHi = 0U;
  c4_info[55].mFileTimeLo = 0U;
  c4_info[55].mFileTimeHi = 0U;
  c4_info[56].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[56].name = "eml_scalar_eg";
  c4_info[56].dominantType = "double";
  c4_info[56].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c4_info[56].fileTimeLo = 1286818796U;
  c4_info[56].fileTimeHi = 0U;
  c4_info[56].mFileTimeLo = 0U;
  c4_info[56].mFileTimeHi = 0U;
  c4_info[57].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[57].name = "eml_scalexp_alloc";
  c4_info[57].dominantType = "double";
  c4_info[57].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c4_info[57].fileTimeLo = 1330608434U;
  c4_info[57].fileTimeHi = 0U;
  c4_info[57].mFileTimeLo = 0U;
  c4_info[57].mFileTimeHi = 0U;
  c4_info[58].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[58].name = "floor";
  c4_info[58].dominantType = "double";
  c4_info[58].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[58].fileTimeLo = 1286818742U;
  c4_info[58].fileTimeHi = 0U;
  c4_info[58].mFileTimeLo = 0U;
  c4_info[58].mFileTimeHi = 0U;
  c4_info[59].context = "";
  c4_info[59].name = "sqrt";
  c4_info[59].dominantType = "double";
  c4_info[59].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c4_info[59].fileTimeLo = 1286818752U;
  c4_info[59].fileTimeHi = 0U;
  c4_info[59].mFileTimeLo = 0U;
  c4_info[59].mFileTimeHi = 0U;
  c4_info[60].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c4_info[60].name = "eml_error";
  c4_info[60].dominantType = "char";
  c4_info[60].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c4_info[60].fileTimeLo = 1305318000U;
  c4_info[60].fileTimeHi = 0U;
  c4_info[60].mFileTimeLo = 0U;
  c4_info[60].mFileTimeHi = 0U;
  c4_info[61].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c4_info[61].name = "eml_scalar_sqrt";
  c4_info[61].dominantType = "double";
  c4_info[61].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c4_info[61].fileTimeLo = 1286818738U;
  c4_info[61].fileTimeHi = 0U;
  c4_info[61].mFileTimeLo = 0U;
  c4_info[61].mFileTimeHi = 0U;
  c4_info[62].context = "";
  c4_info[62].name = "mrdivide";
  c4_info[62].dominantType = "double";
  c4_info[62].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[62].fileTimeLo = 1342810944U;
  c4_info[62].fileTimeHi = 0U;
  c4_info[62].mFileTimeLo = 1319729966U;
  c4_info[62].mFileTimeHi = 0U;
  c4_info[63].context = "";
  c4_info[63].name = "mpower";
  c4_info[63].dominantType = "double";
  c4_info[63].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c4_info[63].fileTimeLo = 1286818842U;
  c4_info[63].fileTimeHi = 0U;
  c4_info[63].mFileTimeLo = 0U;
  c4_info[63].mFileTimeHi = 0U;
}

static real_T c4_norm(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
                      real_T c4_x[2])
{
  real_T c4_y;
  real_T c4_scale;
  int32_T c4_k;
  int32_T c4_b_k;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_absxk;
  real_T c4_t;
  c4_y = 0.0;
  c4_eml_realmin(chartInstance);
  c4_scale = 2.2250738585072014E-308;
  c4_check_forloop_overflow_error(chartInstance);
  for (c4_k = 1; c4_k < 3; c4_k++) {
    c4_b_k = c4_k;
    c4_b_x = c4_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c4_b_k), 1, 2, 1, 0) - 1];
    c4_c_x = c4_b_x;
    c4_absxk = muDoubleScalarAbs(c4_c_x);
    if (c4_absxk > c4_scale) {
      c4_t = c4_scale / c4_absxk;
      c4_y = 1.0 + c4_y * c4_t * c4_t;
      c4_scale = c4_absxk;
    } else {
      c4_t = c4_absxk / c4_scale;
      c4_y += c4_t * c4_t;
    }
  }

  return c4_scale * muDoubleScalarSqrt(c4_y);
}

static void c4_eml_realmin(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

static void c4_check_forloop_overflow_error
  (SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
}

static void c4_CollisionDetection(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c4_v_o[2], real_T c4_obs[2], real_T c4_ro, real_T
  c4_eta[3], real_T c4_V_vessel[3], real_T c4_target[2], real_T
  *c4_CollisionThreat, real_T *c4_DistanceToClosesCollision)
{
  uint32_T c4_debug_family_var_map[18];
  real_T c4_chi_v;
  real_T c4_chi_o;
  real_T c4_V_o;
  real_T c4_t[51];
  real_T c4_V_v;
  real_T c4_O[102];
  real_T c4_N[102];
  real_T c4_D[51];
  real_T c4_nargin = 6.0;
  real_T c4_nargout = 2.0;
  int32_T c4_i99;
  real_T c4_b_v_o[2];
  int32_T c4_i100;
  int32_T c4_i101;
  real_T c4_b_V_vessel[3];
  real_T c4_a;
  int32_T c4_i102;
  real_T c4_y[51];
  real_T c4_x;
  real_T c4_b_x;
  real_T c4_b;
  int32_T c4_i103;
  real_T c4_b_a;
  int32_T c4_i104;
  real_T c4_b_y[51];
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_b_b;
  int32_T c4_i105;
  real_T c4_b_obs;
  real_T c4_c_obs;
  int32_T c4_i106;
  int32_T c4_i107;
  int32_T c4_i108;
  int32_T c4_i109;
  real_T c4_c_a;
  int32_T c4_i110;
  real_T c4_e_x;
  real_T c4_f_x;
  real_T c4_c_b;
  int32_T c4_i111;
  real_T c4_d_a;
  int32_T c4_i112;
  real_T c4_g_x;
  real_T c4_h_x;
  real_T c4_d_b;
  int32_T c4_i113;
  real_T c4_b_eta;
  real_T c4_c_eta;
  int32_T c4_i114;
  int32_T c4_i115;
  int32_T c4_i116;
  int32_T c4_i117;
  int32_T c4_i118;
  int32_T c4_i119;
  real_T c4_b_O[51];
  int32_T c4_i120;
  int32_T c4_i121;
  real_T c4_c_O[51];
  int32_T c4_i122;
  int32_T c4_i123;
  int32_T c4_k;
  real_T c4_b_k;
  int32_T c4_c_k;
  real_T c4_i_x;
  real_T c4_j_x;
  int32_T c4_i;
  real_T c4_b_i;
  int32_T c4_c_i;
  int32_T c4_i124;
  real_T c4_d_O[2];
  int32_T exitg1;
  sf_debug_symbol_scope_push_eml(0U, 18U, 18U, c4_b_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c4_chi_v, 0U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_chi_o, 1U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_V_o, 2U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c4_t, 3U, c4_k_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_V_v, 4U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_O, 5U, c4_l_sf_marshallOut,
    c4_k_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_N, 6U, c4_l_sf_marshallOut,
    c4_k_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_D, 7U, c4_k_sf_marshallOut,
    c4_j_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 8U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 9U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_v_o, 10U, c4_e_sf_marshallOut,
    c4_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_obs, 11U, c4_e_sf_marshallOut,
    c4_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_ro, 12U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_eta, 13U, c4_i_sf_marshallOut,
    c4_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_V_vessel, 14U, c4_i_sf_marshallOut,
    c4_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_target, 15U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_CollisionThreat, 16U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_DistanceToClosesCollision, 17U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  CV_EML_FCN(0, 4);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 186U);
  *c4_CollisionThreat = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 187U);
  *c4_DistanceToClosesCollision = 9999.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 188U);
  c4_chi_v = c4_atan2(chartInstance, c4_target[1] - c4_eta[1], c4_target[0] -
                      c4_eta[0]);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 189U);
  c4_chi_o = c4_atan2(chartInstance, c4_v_o[1], c4_v_o[0]);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 190U);
  for (c4_i99 = 0; c4_i99 < 2; c4_i99++) {
    c4_b_v_o[c4_i99] = c4_v_o[c4_i99];
  }

  c4_V_o = c4_b_norm(chartInstance, c4_b_v_o);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 191U);
  for (c4_i100 = 0; c4_i100 < 51; c4_i100++) {
    c4_t[c4_i100] = (real_T)c4_i100;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 192U);
  for (c4_i101 = 0; c4_i101 < 3; c4_i101++) {
    c4_b_V_vessel[c4_i101] = c4_V_vessel[c4_i101];
  }

  c4_V_v = c4_c_norm(chartInstance, c4_b_V_vessel);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 195U);
  c4_a = c4_V_o;
  for (c4_i102 = 0; c4_i102 < 51; c4_i102++) {
    c4_y[c4_i102] = c4_a * (real_T)c4_i102;
  }

  c4_x = c4_chi_o;
  c4_b_x = c4_x;
  c4_b_x = muDoubleScalarCos(c4_b_x);
  c4_b = c4_b_x;
  for (c4_i103 = 0; c4_i103 < 51; c4_i103++) {
    c4_y[c4_i103] *= c4_b;
  }

  c4_b_a = c4_V_o;
  for (c4_i104 = 0; c4_i104 < 51; c4_i104++) {
    c4_b_y[c4_i104] = c4_b_a * (real_T)c4_i104;
  }

  c4_c_x = c4_chi_o;
  c4_d_x = c4_c_x;
  c4_d_x = muDoubleScalarSin(c4_d_x);
  c4_b_b = c4_d_x;
  for (c4_i105 = 0; c4_i105 < 51; c4_i105++) {
    c4_b_y[c4_i105] *= c4_b_b;
  }

  c4_b_obs = c4_obs[0];
  c4_c_obs = c4_obs[1];
  c4_i106 = 0;
  for (c4_i107 = 0; c4_i107 < 51; c4_i107++) {
    c4_O[c4_i106] = c4_y[c4_i107] + c4_b_obs;
    c4_i106 += 2;
  }

  c4_i108 = 0;
  for (c4_i109 = 0; c4_i109 < 51; c4_i109++) {
    c4_O[c4_i108 + 1] = c4_b_y[c4_i109] + c4_c_obs;
    c4_i108 += 2;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 196U);
  c4_c_a = c4_V_v;
  for (c4_i110 = 0; c4_i110 < 51; c4_i110++) {
    c4_y[c4_i110] = c4_c_a * (real_T)c4_i110;
  }

  c4_e_x = c4_chi_v;
  c4_f_x = c4_e_x;
  c4_f_x = muDoubleScalarCos(c4_f_x);
  c4_c_b = c4_f_x;
  for (c4_i111 = 0; c4_i111 < 51; c4_i111++) {
    c4_y[c4_i111] *= c4_c_b;
  }

  c4_d_a = c4_V_v;
  for (c4_i112 = 0; c4_i112 < 51; c4_i112++) {
    c4_b_y[c4_i112] = c4_d_a * (real_T)c4_i112;
  }

  c4_g_x = c4_chi_v;
  c4_h_x = c4_g_x;
  c4_h_x = muDoubleScalarSin(c4_h_x);
  c4_d_b = c4_h_x;
  for (c4_i113 = 0; c4_i113 < 51; c4_i113++) {
    c4_b_y[c4_i113] *= c4_d_b;
  }

  c4_b_eta = c4_eta[0];
  c4_c_eta = c4_eta[1];
  c4_i114 = 0;
  for (c4_i115 = 0; c4_i115 < 51; c4_i115++) {
    c4_N[c4_i114] = c4_y[c4_i115] + c4_b_eta;
    c4_i114 += 2;
  }

  c4_i116 = 0;
  for (c4_i117 = 0; c4_i117 < 51; c4_i117++) {
    c4_N[c4_i116 + 1] = c4_b_y[c4_i117] + c4_c_eta;
    c4_i116 += 2;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 198U);
  c4_i118 = 0;
  for (c4_i119 = 0; c4_i119 < 51; c4_i119++) {
    c4_b_O[c4_i119] = c4_O[c4_i118] - c4_N[c4_i118];
    c4_i118 += 2;
  }

  c4_power(chartInstance, c4_b_O, c4_b_y);
  c4_i120 = 0;
  for (c4_i121 = 0; c4_i121 < 51; c4_i121++) {
    c4_c_O[c4_i121] = c4_O[c4_i120 + 1] - c4_N[c4_i120 + 1];
    c4_i120 += 2;
  }

  c4_power(chartInstance, c4_c_O, c4_y);
  for (c4_i122 = 0; c4_i122 < 51; c4_i122++) {
    c4_b_y[c4_i122] += c4_y[c4_i122];
  }

  for (c4_i123 = 0; c4_i123 < 51; c4_i123++) {
    c4_D[c4_i123] = c4_b_y[c4_i123];
  }

  for (c4_k = 0; c4_k < 51; c4_k++) {
    c4_b_k = 1.0 + (real_T)c4_k;
    if (c4_D[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          c4_b_k), 1, 51, 1, 0) - 1] < 0.0) {
      c4_eml_error(chartInstance);
    }
  }

  for (c4_c_k = 0; c4_c_k < 51; c4_c_k++) {
    c4_b_k = 1.0 + (real_T)c4_c_k;
    c4_i_x = c4_D[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      c4_b_k), 1, 51, 1, 0) - 1];
    c4_j_x = c4_i_x;
    c4_j_x = muDoubleScalarSqrt(c4_j_x);
    c4_D[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", c4_b_k),
      1, 51, 1, 0) - 1] = c4_j_x;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 200U);
  c4_i = 0;
  do {
    exitg1 = 0;
    if (c4_i < 51) {
      c4_b_i = 1.0 + (real_T)c4_i;
      CV_EML_FOR(0, 1, 3, 1);
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 201U);
      if (CV_EML_IF(0, 1, 17, c4_D[_SFD_EML_ARRAY_BOUNDS_CHECK("D", (int32_T)
            _SFD_INTEGER_CHECK("i", c4_b_i), 1, 51, 1, 0) - 1] < c4_ro)) {
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 202U);
        *c4_CollisionThreat = 1.0;
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 203U);
        c4_c_i = _SFD_EML_ARRAY_BOUNDS_CHECK("O", (int32_T)_SFD_INTEGER_CHECK(
          "i", c4_b_i), 1, 51, 2, 0) - 1;
        for (c4_i124 = 0; c4_i124 < 2; c4_i124++) {
          c4_d_O[c4_i124] = c4_O[c4_i124 + (c4_c_i << 1)] - c4_eta[c4_i124];
        }

        *c4_DistanceToClosesCollision = c4_norm(chartInstance, c4_d_O);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 204U);
        exitg1 = 1;
      } else {
        c4_i++;
        sf_mex_listen_for_ctrl_c(chartInstance->S);
      }
    } else {
      CV_EML_FOR(0, 1, 3, 0);
      exitg1 = 1;
    }
  } while (exitg1 == 0);

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -204);
  sf_debug_symbol_scope_pop();
}

static real_T c4_atan2(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_y, real_T c4_x)
{
  real_T c4_b_y;
  real_T c4_b_x;
  c4_eml_scalar_eg(chartInstance);
  c4_b_y = c4_y;
  c4_b_x = c4_x;
  return muDoubleScalarAtan2(c4_b_y, c4_b_x);
}

static void c4_eml_scalar_eg(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

static real_T c4_b_norm(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_x[2])
{
  real_T c4_y;
  real_T c4_scale;
  int32_T c4_k;
  int32_T c4_b_k;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_absxk;
  real_T c4_t;
  c4_y = 0.0;
  c4_eml_realmin(chartInstance);
  c4_scale = 2.2250738585072014E-308;
  c4_check_forloop_overflow_error(chartInstance);
  for (c4_k = 1; c4_k < 3; c4_k++) {
    c4_b_k = c4_k;
    c4_b_x = c4_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c4_b_k), 1, 2, 1, 0) - 1];
    c4_c_x = c4_b_x;
    c4_absxk = muDoubleScalarAbs(c4_c_x);
    if (c4_absxk > c4_scale) {
      c4_t = c4_scale / c4_absxk;
      c4_y = 1.0 + c4_y * c4_t * c4_t;
      c4_scale = c4_absxk;
    } else {
      c4_t = c4_absxk / c4_scale;
      c4_y += c4_t * c4_t;
    }
  }

  return c4_scale * muDoubleScalarSqrt(c4_y);
}

static real_T c4_c_norm(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_x[3])
{
  real_T c4_y;
  real_T c4_scale;
  int32_T c4_k;
  int32_T c4_b_k;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_absxk;
  real_T c4_t;
  c4_y = 0.0;
  c4_eml_realmin(chartInstance);
  c4_scale = 2.2250738585072014E-308;
  c4_check_forloop_overflow_error(chartInstance);
  for (c4_k = 1; c4_k < 4; c4_k++) {
    c4_b_k = c4_k;
    c4_b_x = c4_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c4_b_k), 1, 3, 1, 0) - 1];
    c4_c_x = c4_b_x;
    c4_absxk = muDoubleScalarAbs(c4_c_x);
    if (c4_absxk > c4_scale) {
      c4_t = c4_scale / c4_absxk;
      c4_y = 1.0 + c4_y * c4_t * c4_t;
      c4_scale = c4_absxk;
    } else {
      c4_t = c4_absxk / c4_scale;
      c4_y += c4_t * c4_t;
    }
  }

  return c4_scale * muDoubleScalarSqrt(c4_y);
}

static void c4_power(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
                     real_T c4_a[51], real_T c4_y[51])
{
  int32_T c4_k;
  real_T c4_b_k;
  real_T c4_ak;
  for (c4_k = 0; c4_k < 51; c4_k++) {
    c4_b_k = 1.0 + (real_T)c4_k;
    c4_ak = c4_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      c4_b_k), 1, 51, 1, 0) - 1];
    c4_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", c4_b_k),
      1, 51, 1, 0) - 1] = muDoubleScalarPower(c4_ak, 2.0);
  }
}

static void c4_eml_error(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance)
{
  int32_T c4_i125;
  static char_T c4_varargin_1[30] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 's', 'q', 'r', 't', '_', 'd', 'o', 'm', 'a',
    'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c4_u[30];
  const mxArray *c4_y = NULL;
  for (c4_i125 = 0; c4_i125 < 30; c4_i125++) {
    c4_u[c4_i125] = c4_varargin_1[c4_i125];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 10, 0U, 1U, 0U, 2, 1, 30), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c4_y));
}

static real_T c4_ObstacleInpath(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c4_obs[3], real_T c4_ro, real_T c4_eta[3], real_T
  c4_target[2])
{
  real_T c4_St;
  uint32_T c4_debug_family_var_map[18];
  real_T c4_etaWp[2];
  real_T c4_k;
  real_T c4_h;
  real_T c4_eps;
  real_T c4_A;
  real_T c4_B;
  real_T c4_C;
  real_T c4_x1;
  real_T c4_x2;
  real_T c4_y1;
  real_T c4_y2;
  real_T c4_nargin = 4.0;
  real_T c4_nargout = 1.0;
  int32_T c4_i126;
  real_T c4_b_A;
  real_T c4_b_B;
  real_T c4_x;
  real_T c4_y;
  real_T c4_b_x;
  real_T c4_b_y;
  real_T c4_a;
  real_T c4_b;
  real_T c4_c_y;
  real_T c4_b_a;
  real_T c4_b_b;
  real_T c4_d_y;
  real_T c4_c_b;
  real_T c4_d_b;
  real_T c4_e_y;
  real_T c4_c_a;
  real_T c4_e_b;
  real_T c4_f_y;
  real_T c4_f_b;
  real_T c4_g_y;
  real_T c4_d_a;
  real_T c4_g_b;
  real_T c4_h_y;
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_h_b;
  real_T c4_i_y;
  real_T c4_c_A;
  real_T c4_c_B;
  real_T c4_e_x;
  real_T c4_j_y;
  real_T c4_f_x;
  real_T c4_k_y;
  real_T c4_i_b;
  real_T c4_l_y;
  real_T c4_e_a;
  real_T c4_j_b;
  real_T c4_m_y;
  real_T c4_g_x;
  real_T c4_h_x;
  real_T c4_k_b;
  real_T c4_n_y;
  real_T c4_d_A;
  real_T c4_d_B;
  real_T c4_i_x;
  real_T c4_o_y;
  real_T c4_j_x;
  real_T c4_p_y;
  real_T c4_f_a;
  real_T c4_l_b;
  real_T c4_q_y;
  real_T c4_g_a;
  real_T c4_m_b;
  real_T c4_r_y;
  real_T c4_b_x1[2];
  int32_T c4_i127;
  real_T c4_c_x1[2];
  int32_T c4_i128;
  real_T c4_b_eta[2];
  real_T c4_b_x2[2];
  int32_T c4_i129;
  real_T c4_c_x2[2];
  int32_T c4_i130;
  real_T c4_c_eta[2];
  boolean_T guard1 = FALSE;
  sf_debug_symbol_scope_push_eml(0U, 18U, 18U, c4_c_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c4_etaWp, 0U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_k, 1U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_h, 2U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_eps, 3U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_A, 4U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_B, 5U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_C, 6U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_x1, 7U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_x2, 8U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_y1, 9U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_y2, 10U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 11U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 12U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_obs, 13U, c4_i_sf_marshallOut,
    c4_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_ro, 14U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_eta, 15U, c4_i_sf_marshallOut,
    c4_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_target, 16U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_St, 17U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  CV_EML_FCN(0, 3);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 156U);
  c4_St = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 157U);
  for (c4_i126 = 0; c4_i126 < 2; c4_i126++) {
    c4_etaWp[c4_i126] = c4_target[c4_i126] - c4_eta[c4_i126];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 158U);
  c4_b_A = c4_etaWp[1];
  c4_b_B = c4_etaWp[0];
  c4_x = c4_b_A;
  c4_y = c4_b_B;
  c4_b_x = c4_x;
  c4_b_y = c4_y;
  c4_k = c4_b_x / c4_b_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 159U);
  c4_a = c4_eta[0];
  c4_b = c4_k;
  c4_c_y = c4_a * c4_b;
  c4_h = c4_eta[1] - c4_c_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 161U);
  c4_eps = c4_h - c4_obs[1];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 163U);
  c4_A = 1.0 + c4_mpower(chartInstance, c4_k);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 164U);
  c4_b_a = c4_k;
  c4_b_b = c4_eps;
  c4_d_y = c4_b_a * c4_b_b;
  c4_c_b = -c4_obs[0] + c4_d_y;
  c4_B = 2.0 * c4_c_b;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 165U);
  c4_C = (c4_mpower(chartInstance, c4_obs[0]) + c4_mpower(chartInstance, c4_eps))
    - c4_mpower(chartInstance, c4_ro);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 167U);
  c4_d_b = c4_A;
  c4_e_y = 4.0 * c4_d_b;
  c4_c_a = c4_e_y;
  c4_e_b = c4_C;
  c4_f_y = c4_c_a * c4_e_b;
  if (CV_EML_IF(0, 1, 15, c4_mpower(chartInstance, c4_B) - c4_f_y >= 0.1)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 168U);
    c4_f_b = c4_A;
    c4_g_y = 4.0 * c4_f_b;
    c4_d_a = c4_g_y;
    c4_g_b = c4_C;
    c4_h_y = c4_d_a * c4_g_b;
    c4_c_x = c4_mpower(chartInstance, c4_B) - c4_h_y;
    c4_d_x = c4_c_x;
    if (c4_d_x < 0.0) {
      c4_eml_error(chartInstance);
    }

    c4_d_x = muDoubleScalarSqrt(c4_d_x);
    c4_h_b = c4_A;
    c4_i_y = 2.0 * c4_h_b;
    c4_c_A = -c4_B + c4_d_x;
    c4_c_B = c4_i_y;
    c4_e_x = c4_c_A;
    c4_j_y = c4_c_B;
    c4_f_x = c4_e_x;
    c4_k_y = c4_j_y;
    c4_x1 = c4_f_x / c4_k_y;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 169U);
    c4_i_b = c4_A;
    c4_l_y = 4.0 * c4_i_b;
    c4_e_a = c4_l_y;
    c4_j_b = c4_C;
    c4_m_y = c4_e_a * c4_j_b;
    c4_g_x = c4_mpower(chartInstance, c4_B) - c4_m_y;
    c4_h_x = c4_g_x;
    if (c4_h_x < 0.0) {
      c4_eml_error(chartInstance);
    }

    c4_h_x = muDoubleScalarSqrt(c4_h_x);
    c4_k_b = c4_A;
    c4_n_y = 2.0 * c4_k_b;
    c4_d_A = -c4_B - c4_h_x;
    c4_d_B = c4_n_y;
    c4_i_x = c4_d_A;
    c4_o_y = c4_d_B;
    c4_j_x = c4_i_x;
    c4_p_y = c4_o_y;
    c4_x2 = c4_j_x / c4_p_y;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 170U);
    c4_f_a = c4_k;
    c4_l_b = c4_x1;
    c4_q_y = c4_f_a * c4_l_b;
    c4_y1 = c4_q_y + c4_h;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 171U);
    c4_g_a = c4_k;
    c4_m_b = c4_x2;
    c4_r_y = c4_g_a * c4_m_b;
    c4_y2 = c4_r_y + c4_h;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 173U);
    c4_b_x1[0] = c4_x1;
    c4_b_x1[1] = c4_y1;
    for (c4_i127 = 0; c4_i127 < 2; c4_i127++) {
      c4_c_x1[c4_i127] = c4_b_x1[c4_i127] - c4_target[c4_i127];
    }

    for (c4_i128 = 0; c4_i128 < 2; c4_i128++) {
      c4_b_eta[c4_i128] = c4_eta[c4_i128] - c4_target[c4_i128];
    }

    guard1 = FALSE;
    if (CV_EML_COND(0, 1, 12, c4_norm(chartInstance, c4_c_x1) < c4_norm
                    (chartInstance, c4_b_eta))) {
      guard1 = TRUE;
    } else {
      c4_b_x2[0] = c4_x2;
      c4_b_x2[1] = c4_y2;
      for (c4_i129 = 0; c4_i129 < 2; c4_i129++) {
        c4_c_x2[c4_i129] = c4_b_x2[c4_i129] - c4_target[c4_i129];
      }

      for (c4_i130 = 0; c4_i130 < 2; c4_i130++) {
        c4_c_eta[c4_i130] = c4_eta[c4_i130] - c4_target[c4_i130];
      }

      if (CV_EML_COND(0, 1, 13, c4_norm(chartInstance, c4_c_x2) < c4_norm
                      (chartInstance, c4_c_eta))) {
        guard1 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 5, FALSE);
        CV_EML_IF(0, 1, 16, FALSE);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 177U);
        c4_St = 0.0;
      }
    }

    if (guard1 == TRUE) {
      CV_EML_MCDC(0, 1, 5, TRUE);
      CV_EML_IF(0, 1, 16, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 175U);
      c4_St = 1.0;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -177);
  sf_debug_symbol_scope_pop();
  return c4_St;
}

static real_T c4_mpower(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
  real_T c4_a)
{
  real_T c4_b_a;
  real_T c4_c_a;
  real_T c4_ak;
  c4_b_a = c4_a;
  c4_c_a = c4_b_a;
  c4_eml_scalar_eg(chartInstance);
  c4_ak = c4_c_a;
  return muDoubleScalarPower(c4_ak, 2.0);
}

static void c4_ChooseDirection(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, real_T c4_V_obstacle[2], real_T c4_d, real_T
  c4_heading_vehicle, real_T c4_P_veh[2], real_T c4_P_obs[2], real_T c4_target[2],
  real_T *c4_ClockWise, real_T *c4_dist, real_T c4_pos_obs[2], real_T *c4_back)
{
  uint32_T c4_debug_family_var_map[15];
  real_T c4_theta_obstacle;
  real_T c4_kvadrant;
  real_T c4_headsOn;
  real_T c4_nargin = 6.0;
  real_T c4_nargout = 4.0;
  int32_T c4_i131;
  int32_T c4_i132;
  real_T c4_b_V_obstacle[2];
  real_T c4_b_back;
  real_T c4_b_headsOn;
  real_T c4_b_kvadrant;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  real_T c4_b_u;
  const mxArray *c4_b_y = NULL;
  real_T c4_c_u;
  const mxArray *c4_c_y = NULL;
  real_T c4_b;
  real_T c4_b_b;
  int32_T c4_i133;
  real_T c4_b_P_veh[2];
  int32_T c4_i134;
  real_T c4_b_P_obs[2];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  sf_debug_symbol_scope_push_eml(0U, 15U, 15U, c4_g_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c4_theta_obstacle, 0U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_kvadrant, 1U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_headsOn, 2U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 3U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 4U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_V_obstacle, 5U,
    c4_e_sf_marshallOut, c4_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_d, 6U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_heading_vehicle, 7U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_P_veh, 8U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_P_obs, 9U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_target, 10U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_ClockWise, 11U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_dist, 12U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_pos_obs, 13U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_back, 14U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  CV_EML_FCN(0, 5);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 215U);
  *c4_ClockWise = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 216U);
  c4_theta_obstacle = c4_atan2(chartInstance, c4_V_obstacle[1], c4_V_obstacle[0]);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 217U);
  for (c4_i131 = 0; c4_i131 < 2; c4_i131++) {
    c4_pos_obs[c4_i131] = c4_P_obs[c4_i131];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 218U);
  *c4_dist = c4_d;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 224U);
  for (c4_i132 = 0; c4_i132 < 2; c4_i132++) {
    c4_b_V_obstacle[c4_i132] = c4_V_obstacle[c4_i132];
  }

  c4_kvad(chartInstance, c4_heading_vehicle, c4_b_V_obstacle, &c4_b_kvadrant,
          &c4_b_headsOn, &c4_b_back);
  c4_kvadrant = c4_b_kvadrant;
  c4_headsOn = c4_b_headsOn;
  *c4_back = c4_b_back;
  sf_mex_printf("%s =\\n", "kvadrant");
  c4_u = c4_kvadrant;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("disp", 0U, 1U, 14, c4_y);
  sf_mex_printf("%s =\\n", "headsOn");
  c4_b_u = c4_headsOn;
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("disp", 0U, 1U, 14, c4_b_y);
  sf_mex_printf("%s =\\n", "back");
  c4_c_u = *c4_back;
  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", &c4_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_call_debug("disp", 0U, 1U, 14, c4_c_y);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 225U);
  guard3 = FALSE;
  if (CV_EML_COND(0, 1, 14, c4_kvadrant == 3.0)) {
    guard3 = TRUE;
  } else if (CV_EML_COND(0, 1, 15, c4_kvadrant == 4.0)) {
    guard3 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 6, FALSE);
    CV_EML_IF(0, 1, 18, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 227U);
    guard4 = FALSE;
    if (CV_EML_COND(0, 1, 16, c4_kvadrant == 1.0)) {
      guard4 = TRUE;
    } else if (CV_EML_COND(0, 1, 17, c4_kvadrant == 2.0)) {
      guard4 = TRUE;
    } else {
      CV_EML_MCDC(0, 1, 7, FALSE);
      CV_EML_IF(0, 1, 19, FALSE);
    }

    if (guard4 == TRUE) {
      CV_EML_MCDC(0, 1, 7, TRUE);
      CV_EML_IF(0, 1, 19, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 228U);
      *c4_ClockWise = 0.0;
    }
  }

  if (guard3 == TRUE) {
    CV_EML_MCDC(0, 1, 6, TRUE);
    CV_EML_IF(0, 1, 18, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 226U);
    *c4_ClockWise = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 231U);
  if (CV_EML_IF(0, 1, 20, c4_headsOn == 1.0)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 233U);
    guard1 = FALSE;
    if (CV_EML_COND(0, 1, 18, c4_heading_vehicle > 0.0)) {
      if (CV_EML_COND(0, 1, 19, c4_theta_obstacle < 0.0)) {
        CV_EML_MCDC(0, 1, 8, TRUE);
        CV_EML_IF(0, 1, 21, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 234U);
        *c4_ClockWise = 0.0;
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 235U);
        c4_b = c4_d;
        *c4_dist = 2.0 * c4_b;
      } else {
        guard1 = TRUE;
      }
    } else {
      guard1 = TRUE;
    }

    if (guard1 == TRUE) {
      CV_EML_MCDC(0, 1, 8, FALSE);
      CV_EML_IF(0, 1, 21, FALSE);
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 236U);
      guard2 = FALSE;
      if (CV_EML_COND(0, 1, 20, c4_heading_vehicle < 0.0)) {
        if (CV_EML_COND(0, 1, 21, c4_theta_obstacle > 0.0)) {
          CV_EML_MCDC(0, 1, 9, TRUE);
          CV_EML_IF(0, 1, 22, TRUE);
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 237U);
          *c4_ClockWise = 1.0;
          _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 238U);
          c4_b_b = c4_d;
          *c4_dist = 2.0 * c4_b_b;
        } else {
          guard2 = TRUE;
        }
      } else {
        guard2 = TRUE;
      }

      if (guard2 == TRUE) {
        CV_EML_MCDC(0, 1, 9, FALSE);
        CV_EML_IF(0, 1, 22, FALSE);
      }
    }
  } else {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 240U);
    if (CV_EML_IF(0, 1, 23, *c4_back == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 242U);
      for (c4_i133 = 0; c4_i133 < 2; c4_i133++) {
        c4_b_P_veh[c4_i133] = c4_P_veh[c4_i133] - c4_target[c4_i133];
      }

      for (c4_i134 = 0; c4_i134 < 2; c4_i134++) {
        c4_b_P_obs[c4_i134] = c4_P_obs[c4_i134] - c4_target[c4_i134];
      }

      if (CV_EML_IF(0, 1, 24, c4_norm(chartInstance, c4_b_P_veh) < c4_norm
                    (chartInstance, c4_b_P_obs))) {
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 243U);
        *c4_ClockWise = 1.0;
      } else {
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 245U);
        *c4_ClockWise = 0.0;
      }
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -245);
  sf_debug_symbol_scope_pop();
}

static void c4_kvad(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance,
                    real_T c4_heading_vehicle, real_T c4_velocity_obs[2], real_T
                    *c4_kvadra, real_T *c4_headsOn, real_T *c4_back)
{
  uint32_T c4_debug_family_var_map[12];
  real_T c4_HeadsOnConstant;
  real_T c4_collisionFromBehindConstant;
  real_T c4_v_ov[2];
  real_T c4_h_ov_rad;
  real_T c4_temp_angle;
  real_T c4_nargin = 2.0;
  real_T c4_nargout = 3.0;
  real_T c4_dv11[4];
  int32_T c4_i135;
  int32_T c4_i136;
  int32_T c4_i137;
  int32_T c4_i138;
  real_T c4_a[4];
  int32_T c4_i139;
  real_T c4_b[2];
  int32_T c4_i140;
  int32_T c4_i141;
  int32_T c4_i142;
  real_T c4_C[2];
  int32_T c4_i143;
  int32_T c4_i144;
  int32_T c4_i145;
  int32_T c4_i146;
  int32_T c4_i147;
  int32_T c4_i148;
  int32_T c4_i;
  real_T c4_b_i;
  real_T c4_b_a;
  real_T c4_y;
  real_T c4_A;
  real_T c4_x;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_b_y;
  real_T c4_e_x;
  real_T c4_f_x;
  real_T c4_c_y;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  sf_debug_symbol_scope_push_eml(0U, 12U, 12U, c4_f_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c4_HeadsOnConstant, 0U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_collisionFromBehindConstant, 1U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_v_ov, 2U, c4_g_sf_marshallOut,
    c4_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_h_ov_rad, 3U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_temp_angle, 4U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 5U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 6U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_heading_vehicle, 7U,
    c4_j_sf_marshallOut, c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_velocity_obs, 8U,
    c4_e_sf_marshallOut, c4_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_kvadra, 9U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_headsOn, 10U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_back, 11U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  CV_EML_FCN(0, 2);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 118);
  c4_HeadsOnConstant = 0.35;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 119);
  c4_collisionFromBehindConstant = 0.2;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 120);
  c4_R(chartInstance, c4_heading_vehicle, c4_dv11);
  c4_i135 = 0;
  for (c4_i136 = 0; c4_i136 < 2; c4_i136++) {
    c4_i137 = 0;
    for (c4_i138 = 0; c4_i138 < 2; c4_i138++) {
      c4_a[c4_i138 + c4_i135] = c4_dv11[c4_i137 + c4_i136];
      c4_i137 += 2;
    }

    c4_i135 += 2;
  }

  for (c4_i139 = 0; c4_i139 < 2; c4_i139++) {
    c4_b[c4_i139] = c4_velocity_obs[c4_i139];
  }

  c4_b_eml_scalar_eg(chartInstance);
  c4_b_eml_scalar_eg(chartInstance);
  for (c4_i140 = 0; c4_i140 < 2; c4_i140++) {
    c4_v_ov[c4_i140] = 0.0;
  }

  for (c4_i141 = 0; c4_i141 < 2; c4_i141++) {
    c4_v_ov[c4_i141] = 0.0;
  }

  for (c4_i142 = 0; c4_i142 < 2; c4_i142++) {
    c4_C[c4_i142] = c4_v_ov[c4_i142];
  }

  for (c4_i143 = 0; c4_i143 < 2; c4_i143++) {
    c4_v_ov[c4_i143] = c4_C[c4_i143];
  }

  for (c4_i144 = 0; c4_i144 < 2; c4_i144++) {
    c4_C[c4_i144] = c4_v_ov[c4_i144];
  }

  for (c4_i145 = 0; c4_i145 < 2; c4_i145++) {
    c4_v_ov[c4_i145] = c4_C[c4_i145];
  }

  for (c4_i146 = 0; c4_i146 < 2; c4_i146++) {
    c4_v_ov[c4_i146] = 0.0;
    c4_i147 = 0;
    for (c4_i148 = 0; c4_i148 < 2; c4_i148++) {
      c4_v_ov[c4_i146] += c4_a[c4_i147 + c4_i146] * c4_b[c4_i148];
      c4_i147 += 2;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 121);
  c4_h_ov_rad = c4_atan2(chartInstance, c4_v_ov[1], c4_v_ov[0]);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 124);
  if (CV_EML_IF(0, 1, 11, c4_h_ov_rad < 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 125);
    c4_h_ov_rad += 6.2831853071795862;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, MAX_int8_T);
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 129U);
  *c4_kvadra = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 131U);
  c4_i = 0;
  while (c4_i < 4) {
    c4_b_i = (real_T)c4_i;
    CV_EML_FOR(0, 1, 2, 1);
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 132U);
    c4_b_a = c4_b_i;
    c4_y = c4_b_a * 3.1415926535897931;
    c4_A = c4_y;
    c4_x = c4_A;
    c4_b_x = c4_x;
    c4_temp_angle = c4_b_x / 2.0;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 133U);
    guard2 = FALSE;
    if (CV_EML_COND(0, 1, 8, c4_h_ov_rad >= c4_temp_angle)) {
      if (CV_EML_COND(0, 1, 9, c4_h_ov_rad < c4_temp_angle + 1.5707963267948966))
      {
        CV_EML_MCDC(0, 1, 3, TRUE);
        CV_EML_IF(0, 1, 12, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 134U);
        *c4_kvadra = c4_b_i + 1.0;
      } else {
        guard2 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }

    if (guard2 == TRUE) {
      CV_EML_MCDC(0, 1, 3, FALSE);
      CV_EML_IF(0, 1, 12, FALSE);
    }

    c4_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 2, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 139U);
  c4_c_x = c4_h_ov_rad - 3.1415926535897931;
  c4_d_x = c4_c_x;
  c4_b_y = muDoubleScalarAbs(c4_d_x);
  if (CV_EML_IF(0, 1, 13, c4_b_y < c4_HeadsOnConstant)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 140U);
    *c4_headsOn = 1.0;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 141U);
    *c4_back = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 142U);
    guard1 = FALSE;
    if (CV_EML_COND(0, 1, 10, c4_h_ov_rad < c4_collisionFromBehindConstant)) {
      guard1 = TRUE;
    } else {
      c4_e_x = c4_h_ov_rad - 6.2831853071795862;
      c4_f_x = c4_e_x;
      c4_c_y = muDoubleScalarAbs(c4_f_x);
      if (CV_EML_COND(0, 1, 11, c4_c_y < c4_collisionFromBehindConstant)) {
        guard1 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 4, FALSE);
        CV_EML_IF(0, 1, 14, FALSE);
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 146U);
        *c4_headsOn = 0.0;
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 147U);
        *c4_back = 0.0;
      }
    }

    if (guard1 == TRUE) {
      CV_EML_MCDC(0, 1, 4, TRUE);
      CV_EML_IF(0, 1, 14, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 143U);
      *c4_back = 1.0;
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 144U);
      *c4_headsOn = 0.0;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -147);
  sf_debug_symbol_scope_pop();
}

static void c4_R(SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance, real_T
                 c4_theta, real_T c4_R_matrix[4])
{
  uint32_T c4_debug_family_var_map[4];
  real_T c4_nargin = 1.0;
  real_T c4_nargout = 1.0;
  real_T c4_x;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_e_x;
  real_T c4_f_x;
  real_T c4_g_x;
  real_T c4_h_x;
  sf_debug_symbol_scope_push_eml(0U, 4U, 4U, c4_e_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 0U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 1U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_theta, 2U, c4_j_sf_marshallOut,
    c4_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_R_matrix, 3U, c4_n_sf_marshallOut,
    c4_m_sf_marshallIn);
  CV_EML_FCN(0, 1);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 111);
  c4_x = c4_theta;
  c4_b_x = c4_x;
  c4_b_x = muDoubleScalarCos(c4_b_x);
  c4_c_x = c4_theta;
  c4_d_x = c4_c_x;
  c4_d_x = muDoubleScalarSin(c4_d_x);
  c4_e_x = c4_theta;
  c4_f_x = c4_e_x;
  c4_f_x = muDoubleScalarSin(c4_f_x);
  c4_g_x = c4_theta;
  c4_h_x = c4_g_x;
  c4_h_x = muDoubleScalarCos(c4_h_x);
  c4_R_matrix[0] = c4_b_x;
  c4_R_matrix[2] = -c4_d_x;
  c4_R_matrix[1] = c4_f_x;
  c4_R_matrix[3] = c4_h_x;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -111);
  sf_debug_symbol_scope_pop();
}

static void c4_b_eml_scalar_eg(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

static const mxArray *c4_o_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(int32_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static int32_T c4_u_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  int32_T c4_y;
  int32_T c4_i149;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_i149, 1, 6, 0U, 0, 0U, 0);
  c4_y = c4_i149;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_n_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_sfEvent;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  int32_T c4_y;
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)chartInstanceVoid;
  c4_b_sfEvent = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_u_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_sfEvent),
    &c4_thisId);
  sf_mex_destroy(&c4_b_sfEvent);
  *(int32_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static uint8_T c4_v_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_b_is_active_c4_NSB_vehicle_simulator, const
  char_T *c4_identifier)
{
  uint8_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_w_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c4_b_is_active_c4_NSB_vehicle_simulator), &c4_thisId);
  sf_mex_destroy(&c4_b_is_active_c4_NSB_vehicle_simulator);
  return c4_y;
}

static uint8_T c4_w_emlrt_marshallIn(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_u0, 1, 3, 0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void init_dsm_address_info(SFc4_NSB_vehicle_simulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c4_NSB_vehicle_simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1832061274U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3539157245U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2243866921U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2960108174U);
}

mxArray *sf_c4_NSB_vehicle_simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("gUzj6WyLRUuKfWJGuvOZdG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(4);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(4);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(7);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c4_NSB_vehicle_simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[21],T\"V_obs\",},{M[1],M[6],T\"obstacleToCollisionAvoidance\",},{M[4],M[0],T\"backSituation\",S'l','i','p'{{M1x2[219 232],M[0],}}},{M[4],M[0],T\"diractionAround\",S'l','i','p'{{M1x2[109 124],M[0],}}},{M[4],M[0],T\"increaseSafetyCircle\",S'l','i','p'{{M1x2[145 165],M[0],}}},{M[4],M[0],T\"lastVelocity\",S'l','i','p'{{M1x2[7182 7194],M[0],}}},{M[4],M[0],T\"safetyCircle\",S'l','i','p'{{M1x2[186 198],M[0],}}},{M[8],M[0],T\"is_active_c4_NSB_vehicle_simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_NSB_vehicle_simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
    chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_NSB_vehicle_simulatorMachineNumber_,
           4,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_NSB_vehicle_simulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_NSB_vehicle_simulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds
            (_NSB_vehicle_simulatorMachineNumber_,
             chartInstance->chartNumber,
             0,
             0,
             0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_vessel");
          _SFD_SET_DATA_PROPS(1,1,1,0,"eta");
          _SFD_SET_DATA_PROPS(2,2,0,1,"obstacleToCollisionAvoidance");
          _SFD_SET_DATA_PROPS(3,1,1,0,"obslist");
          _SFD_SET_DATA_PROPS(4,1,1,0,"velObs");
          _SFD_SET_DATA_PROPS(5,2,0,1,"V_obs");
          _SFD_SET_DATA_PROPS(6,1,1,0,"target");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,7,27,0,0,0,4,0,22,10);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,3420);
        _SFD_CV_INIT_EML_FCN(0,1,"R",3422,-1,3524);
        _SFD_CV_INIT_EML_FCN(0,2,"kvad",3526,-1,4417);
        _SFD_CV_INIT_EML_FCN(0,3,"ObstacleInpath",4419,-1,5196);
        _SFD_CV_INIT_EML_FCN(0,4,"CollisionDetection",5199,-1,6088);
        _SFD_CV_INIT_EML_FCN(0,5,"ChooseDirection",6092,-1,7104);
        _SFD_CV_INIT_EML_FCN(0,6,"TestObstacleDiraction",7107,-1,7444);
        _SFD_CV_INIT_EML_IF(0,1,0,238,265,-1,303);
        _SFD_CV_INIT_EML_IF(0,1,1,309,334,-1,370);
        _SFD_CV_INIT_EML_IF(0,1,2,376,400,-1,434);
        _SFD_CV_INIT_EML_IF(0,1,3,439,471,-1,512);
        _SFD_CV_INIT_EML_IF(0,1,4,1090,1118,-1,1181);
        _SFD_CV_INIT_EML_IF(0,1,5,1271,1290,-1,1944);
        _SFD_CV_INIT_EML_IF(0,1,6,1510,1596,-1,1930);
        _SFD_CV_INIT_EML_IF(0,1,7,2353,2438,3228,3301);
        _SFD_CV_INIT_EML_IF(0,1,8,2522,2542,2885,2909);
        _SFD_CV_INIT_EML_IF(0,1,9,2885,2909,-1,2909);
        _SFD_CV_INIT_EML_IF(0,1,10,2996,3066,-1,3222);
        _SFD_CV_INIT_EML_IF(0,1,11,3831,3846,3887,3928);
        _SFD_CV_INIT_EML_IF(0,1,12,4005,4061,-1,4099);
        _SFD_CV_INIT_EML_IF(0,1,13,4132,4170,4214,4407);
        _SFD_CV_INIT_EML_IF(0,1,14,4214,4312,4356,4407);
        _SFD_CV_INIT_EML_IF(0,1,15,4840,4859,-1,5183);
        _SFD_CV_INIT_EML_IF(0,1,16,5006,5103,5138,5175);
        _SFD_CV_INIT_EML_IF(0,1,17,5940,5952,-1,-2);
        _SFD_CV_INIT_EML_IF(0,1,18,6503,6535,6563,6600);
        _SFD_CV_INIT_EML_IF(0,1,19,6563,6600,-1,6600);
        _SFD_CV_INIT_EML_IF(0,1,20,6641,6656,6907,6923);
        _SFD_CV_INIT_EML_IF(0,1,21,6674,6718,6786,6834);
        _SFD_CV_INIT_EML_IF(0,1,22,6786,6834,-1,6834);
        _SFD_CV_INIT_EML_IF(0,1,23,6907,6923,-1,6923);
        _SFD_CV_INIT_EML_IF(0,1,24,6933,6975,7034,7077);
        _SFD_CV_INIT_EML_IF(0,1,25,7200,7224,-1,7283);
        _SFD_CV_INIT_EML_IF(0,1,26,7294,7337,7367,7404);
        _SFD_CV_INIT_EML_FOR(0,1,0,984,1010,1191);
        _SFD_CV_INIT_EML_FOR(0,1,1,1232,1263,1952);
        _SFD_CV_INIT_EML_FOR(0,1,2,3953,3967,4116);
        _SFD_CV_INIT_EML_FOR(0,1,3,5913,5933,6083);

        {
          static int condStart[] = { 1514, 1570 };

          static int condEnd[] = { 1566, 1595 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,1514,1595,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 2357, 2381, 2404, 2418 };

          static int condEnd[] = { 2377, 2399, 2415, 2438 };

          static int pfixExpr[] = { 0, 1, -2, 2, -3, 3, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,2356,2438,4,2,&(condStart[0]),&(condEnd[0]),
                                7,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 2999, 3021 };

          static int condEnd[] = { 3017, 3066 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,2999,3066,2,6,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 4008, 4034 };

          static int condEnd[] = { 4030, 4061 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,3,4008,4061,2,8,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 4221, 4263 };

          static int condEnd[] = { 4259, 4312 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,4,4221,4312,2,10,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 5009, 5058 };

          static int condEnd[] = { 5054, 5103 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,5,5009,5103,2,12,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 6506, 6522 };

          static int condEnd[] = { 6519, 6535 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,6,6506,6535,2,14,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 6570, 6587 };

          static int condEnd[] = { 6583, 6600 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,7,6570,6600,2,16,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 6677, 6700 };

          static int condEnd[] = { 6696, 6718 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,8,6677,6718,2,18,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 6793, 6816 };

          static int condEnd[] = { 6812, 6834 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,9,6793,6834,2,20,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_i_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_i_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 7;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_f_sf_marshallOut,(MexInFcnForType)
            c4_f_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_h_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_h_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_e_sf_marshallOut,(MexInFcnForType)
            c4_e_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_g_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c4_v_vessel)[3];
          real_T (*c4_eta)[3];
          real_T (*c4_obstacleToCollisionAvoidance)[7];
          real_T (*c4_obslist)[4];
          real_T (*c4_velObs)[4];
          real_T (*c4_V_obs)[2];
          real_T (*c4_target)[2];
          c4_target = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 4);
          c4_V_obs = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 2);
          c4_velObs = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
          c4_obslist = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
          c4_obstacleToCollisionAvoidance = (real_T (*)[7])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c4_eta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c4_v_vessel = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c4_v_vessel);
          _SFD_SET_DATA_VALUE_PTR(1U, *c4_eta);
          _SFD_SET_DATA_VALUE_PTR(2U, *c4_obstacleToCollisionAvoidance);
          _SFD_SET_DATA_VALUE_PTR(3U, *c4_obslist);
          _SFD_SET_DATA_VALUE_PTR(4U, *c4_velObs);
          _SFD_SET_DATA_VALUE_PTR(5U, *c4_V_obs);
          _SFD_SET_DATA_VALUE_PTR(6U, *c4_target);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_NSB_vehicle_simulatorMachineNumber_,chartInstance->chartNumber,
         chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "XVw21G5ZGvW5r27FnWRkHH";
}

static void sf_opaque_initialize_c4_NSB_vehicle_simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc4_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c4_NSB_vehicle_simulator
    ((SFc4_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar);
  initialize_c4_NSB_vehicle_simulator((SFc4_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c4_NSB_vehicle_simulator(void *chartInstanceVar)
{
  enable_c4_NSB_vehicle_simulator((SFc4_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c4_NSB_vehicle_simulator(void *chartInstanceVar)
{
  disable_c4_NSB_vehicle_simulator((SFc4_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c4_NSB_vehicle_simulator(void *chartInstanceVar)
{
  sf_c4_NSB_vehicle_simulator((SFc4_NSB_vehicle_simulatorInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c4_NSB_vehicle_simulator
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c4_NSB_vehicle_simulator
    ((SFc4_NSB_vehicle_simulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_NSB_vehicle_simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c4_NSB_vehicle_simulator(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_NSB_vehicle_simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c4_NSB_vehicle_simulator
    ((SFc4_NSB_vehicle_simulatorInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c4_NSB_vehicle_simulator(SimStruct*
  S)
{
  return sf_internal_get_sim_state_c4_NSB_vehicle_simulator(S);
}

static void sf_opaque_set_sim_state_c4_NSB_vehicle_simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c4_NSB_vehicle_simulator(S, st);
}

static void sf_opaque_terminate_c4_NSB_vehicle_simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc4_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar)
      ->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c4_NSB_vehicle_simulator((SFc4_NSB_vehicle_simulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_NSB_vehicle_simulator_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc4_NSB_vehicle_simulator
    ((SFc4_NSB_vehicle_simulatorInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_NSB_vehicle_simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_NSB_vehicle_simulator
      ((SFc4_NSB_vehicle_simulatorInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c4_NSB_vehicle_simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_NSB_vehicle_simulator_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,4,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,4,5);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,4,2);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1964919721U));
  ssSetChecksum1(S,(2128272177U));
  ssSetChecksum2(S,(207366492U));
  ssSetChecksum3(S,(1095975417U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c4_NSB_vehicle_simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_NSB_vehicle_simulator(SimStruct *S)
{
  SFc4_NSB_vehicle_simulatorInstanceStruct *chartInstance;
  chartInstance = (SFc4_NSB_vehicle_simulatorInstanceStruct *)malloc(sizeof
    (SFc4_NSB_vehicle_simulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc4_NSB_vehicle_simulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c4_NSB_vehicle_simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c4_NSB_vehicle_simulator_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_NSB_vehicle_simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_NSB_vehicle_simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_NSB_vehicle_simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_NSB_vehicle_simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
